$(function() {
	
FastButton = function(element, handler) {
  this.element = element;
  this.handler = handler;

  element.addEventListener('touchstart', this, false);
  element.addEventListener('click', this, false);
  element.addEventListener('mousedown', this, false);
};

FastButton.prototype.handleEvent = function(event) {
  switch (event.type) {
    case 'touchstart': this.onTouchStart(event); break;
    case 'touchmove': this.onTouchMove(event); break;
    case 'touchend': this.onClick(event); break;
    case 'click': this.onClick(event); break;
    case 'mousedown': this.onClick(event); break;
  }
};
	
FastButton.prototype.onTouchStart = function(event) {
  event.stopPropagation();

  this.element.addEventListener('touchend', this, false);
  document.body.addEventListener('touchmove', this, false);

  this.startX = event.touches[0].clientX;
  this.startY = event.touches[0].clientY;
};

FastButton.prototype.onTouchMove = function(event) {
  if (Math.abs(event.touches[0].clientX - this.startX) > 10 ||
      Math.abs(event.touches[0].clientY - this.startY) > 10) {
    this.reset();
  }
};

FastButton.prototype.onClick = function(event) {
  event.stopPropagation();
  this.reset();
  this.handler(event);

  if (event.type == 'touchend') {
    clickbuster_preventGhostClick(this.startX, this.startY);
  }
};

FastButton.prototype.reset = function() {
  this.element.removeEventListener('touchend', this, false);
  document.body.removeEventListener('touchmove', this, false);
};

clickbuster_preventGhostClick = function(x, y) {
  clickbuster_coordinates.push(x, y);
  window.setTimeout(clickbuster_pop, 2500);
};

clickbuster_pop = function() {
  clickbuster_coordinates.splice(0, 2);
};

clickbuster_onClick = function(event) {
  for (var i = 0; i < clickbuster_coordinates.length; i += 2) {
    var x = clickbuster_coordinates[i];
    var y = clickbuster_coordinates[i + 1];
    if (Math.abs(event.clientX - x) < 25 && Math.abs(event.clientY - y) < 25) {
      event.stopPropagation();
      event.preventDefault();
    }
  }
};

document.addEventListener('click', clickbuster_onClick, true);
clickbuster_coordinates = [];



	$(".ui-dialog-buttonset .ui-button").each(function(index, element) {
		if ($(this).text() == "OK") {
			//$(this).mousedown(function() {
			//	$(this).click();
			//});

			//var okbtn = $(this);
			var thedialog = $(this).parent().parent().parent().children(".ui-dialog-content");
			var buttons = thedialog.dialog("option", "buttons");
			
			new FastButton(element, function() {
				thedialog.dialog("close"); 
				//buttons["OK"].apply(); 
				setTimeout( function() { buttons["OK"].apply(); }, 0 );
			});
		}

		//$(this).bind("mousedown", this.click);
		//element.addEventListener('mousedown', this, false);
	});
	


	
	 
});