/* vim: set filetype=javascript: */
function loadFileBrowserJS() {

	//------------------------------------------------------------
	// SET UP TABS, ADD TASK, DELETE TASK
	//------------------------------------------------------------
	//set up tabs
	$("#file_browser_tabbar").on("mousedown", "div.btn-tab", function() {
        selectNonTaskTab($(this).index());
        loadFileBrowserIframe($(this).index());
    });

    $("#pdfjs_viewer").load(function() {    //set up Close X in PDF JS viewer iframe
        if ($(this).attr('src') != "") {
            $(this).contents().find("#closeViewer").click(function(e) {
                e.preventDefault();
                $("#pdfjs_viewer").hide().attr('src', "");
            });
        }
    });

    //when dir iframe src changes, readjust sizing
    $(".file_browser_dir_content iframe").load(function() {
        if ($(this).attr('src') != "") {
            adjustFileBrowserIframeSize();
			$(this).closest('.mCSB_container').css({top: "0px"});

            //capture link clicks within iframe and open file in dialog
            var that = this;
            $(this).contents().find("a[data-download='file']").click(function(e) {
                e.preventDefault();
                var href = $(that).get(0).contentWindow.location.href + $(this).attr('href');
                var mimetype = $(this).attr('data-mime');
                var encoding = $(this).attr('file-encoding');
                if (mimetype == "application/pdf") {   //open PDF JS viewer
                    $("#file_browser_file_content #xml_container").hide();
                    $("#file_browser_file_content iframe").hide();
                    $("#file_browser_file_content #html_container").hide();
                    $("#pdfjs_viewer").attr('src', '/js/pdfjs/web/viewer.html?file=' + href + '#page=1').show();
                }
                else {  //open modal
                    if (mimetype == "application/xml") {
                        $("#file_browser_file_content #html_container").hide();
                        $("#file_browser_file_content iframe").hide();
                        $("#file_browser_file_content #xml_container script").load(href, function() {
                            $("#file_browser_file_content #xml_container").show();
                        });
                    }
                    // Don't view tiff, ico, and rtf files
                    else if ((mimetype.indexOf("image") > -1 && (mimetype.indexOf("tiff") == -1 && mimetype.indexOf("ico") == -1)) ||
                             (mimetype.indexOf("text") > -1 && (mimetype.indexOf("rtf") == -1))) {
                        $("#file_browser_file_content #xml_container").hide();
                        $("#file_browser_file_content #html_container").hide();

                        // If text and encoding is unknown, try encoding
                        // specified in language file
                        if (mimetype.indexOf("text") > -1 && encoding.indexOf("utf-8") == -1) {
                            $.ajax({ url: '/convert.php',
                                     data: {path: href},
                                     type: 'post',
                                     success: function(output) {
                                         $("#file_browser_file_content iframe").removeAttr('src');
                                         $("#file_browser_file_content iframe").attr('srcdoc', output).show();
                                     }
                            });
                        }
                        else {
                            $("#file_browser_file_content iframe").removeAttr('srcdoc');
                            $("#file_browser_file_content iframe").attr('src', href).show();
                        }
                    }
                    else {
                        $("#file_browser_file_content #xml_container").hide();
                        $("#file_browser_file_content iframe").hide();
				        var msg = "<?= t("FILE_IS_NOT_VIEWABLE"); ?>";
				        msg = msg.replace("%1", mimetype);
                        $("#file_browser_file_content #html_container").html(msg).show();
                    }
                    $("#file_browser_file_dialog").dialog('option', 'title', decodeURIComponent(href.substring(href.indexOf('/bays/')+5)));
                    $("#file_browser_file_dialog").dialog('open');
                }
            });
        }
    });

    //when file dialog loaded, adjust iframe size
    //var file_iframe_height = 0;
    $("#file_browser_file_content iframe").load(function(e) {
        if ($(this).attr('src') != "") {
            adjustFileBrowserIframeSize();
			$(this).closest('.mCSB_container').css({top: "0px"});
        }
    });

    $("#file_browser_file_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
			$("#file_browser_file_content iframe").attr('src', "");
            $("#file_browser_file_content iframe").css({ height: "0px" });
			$("#mcs_container33").mCustomScrollbar("scrollTo", "top");
		}
	});
}

//update iframe src, adjust size, capture clicks
function loadFileBrowserIframe(tab) {
    //console.log('loadFileBrowserIframe');
    var dir_iframe_obj = $("#file_browser_page_" + tab + " .file_browser_dir_content iframe");
    dir_iframe_obj.attr('src', $("#file_browser_tab_" + tab).attr('data-path'));
}

//set zoom and height for File Browser directory and file iframes
function adjustFileBrowserIframeSize() {
    if ($("body").css("transform") != "none" && typeof($("body").css("transform")) != "undefined") { //Firefox
        var transform = $("body").css("transform");	//matrix(scaleX,0,0,scaleY,0,0)
        var zoom = transform.substring(7, transform.indexOf(","));
    }
    else {	//Chrome
        var zoom = $("body").css("zoom");
        if (typeof(zoom) == "undefined" || zoom == "none") zoom = 1;
    }

    //set zoom and height for directory iframes
    $(".file_browser_dir_content iframe").each(function() {
        if ($(this).attr('src') != "") {
            $(this).contents().find('body').css('zoom', zoom);
            var dir_iframe_ht = Math.ceil($(this).contents().find('html').height() / zoom);
            $(this).css({ height: dir_iframe_ht + "px" });
        }
    });

    //set zoom and height for file iframe
    if ($("#file_browser_file_content iframe").attr('src') != "") {
        $("#file_browser_file_content iframe").contents().find('body').css('zoom', zoom);
        var contents_ht = $("#file_browser_file_content iframe").contents().find('body').height();
        var file_iframe_ht = Math.ceil(contents_ht / zoom);
        $("#file_browser_file_content iframe").css({ height: file_iframe_ht + "px" });
    }
}
