/* vim: set filetype=javascript: */

//Set up Main Nav buttons and up/down arrows
$(function() {
	//reset unlock timer on mousedown keydown
	$("body").on("mousedown keydown", function(event) {
		if (!systemLocked()) {
			setCookie('unlocked', '1', passkey_config['Timeout']);	//set cookie
		}
	});

	//set up Config Lock, prevent lock-button buttons from firing events
	//need the 'key_validated' variable for when Auto Lock timeout = 0 (system is locked but user has unlocked current function)
	//NOTE: this needs to be here BEFORE mousedown events are set up for lockable elements
	$(".lock-button").on("mousedown", function(event) {
		if ($(this).attr('disabled') != 'disabled') {
			if (systemLocked() && !$(this).hasClass('key_validated')) {
				event.stopImmediatePropagation();	//stop events in same node from firing
				passkey_config['Callback'] = $(this).attr('id');
				$("#settings_unlock_dialog").data('name', 'ConfigLock');
				$("#settings_unlock_dialog").dialog('option', 'title', "<?= t("ENTER_KEY_TO_UNLOCK"); ?>");
				$("#settings_unlock_dialog").dialog('open');
			}
			else {
				$(this).removeClass('key_validated');
			}
		}
	});

	//set up Audit Log Lock, prevent file-lock-button buttons from firing events
	$(".file-lock-button").on("mousedown", function(event) {
		if ($(this).attr('disabled') != 'disabled') {
			if ((logkey_config['Key'] == 'Set' && logkey_config['Enabled']) && !$(this).hasClass('key_validated')) {
				event.stopImmediatePropagation();	//stop events in same node from firing
				logkey_config['Callback'] = $(this).attr('id');
				$("#settings_unlock_dialog").data('name', 'AuditLog');
				$("#settings_unlock_dialog").dialog('option', 'title', "<?php if ($LOGICUBE_PLATFORM == "zclonexi" || $LOGICUBE_PLATFORM == "zxtower"): ?><?= t("ENTER_FILE_DELETION_PASSWORD_TO_UNLOCK"); ?><?php else: ?><?= t("ENTER_LOG_FILE_DELETION_PASSWORD_TO_UNLOCK"); ?><?php endif; ?>");
				$("#settings_unlock_dialog").dialog('open');
			}
			else {
				$(this).removeClass('key_validated');
			}
		}
	});



	var cur_group = 0;	//current button group visible
	var num_groups = Math.ceil($("#nav_buttons .navbtn").length / 4);	//number of button groups
	var cur_page = "clone";		//current page

	$("#nav_up").mousedown(function() {
		cur_group = Math.max(0, cur_group-1);
        var i = cur_group*4 + 1;    //starting nav btn to show
        $("#nav_buttons .navbtn").hide();
        $("#nav_buttons .navbtn:nth-child(n+" + i + "):nth-child(-n+" + (i+3) + ")").css("display", "table");   //show 4 nav btns
	});

	$("#nav_down").mousedown(function() {
		cur_group = Math.min(cur_group+1, num_groups-1);
        var i = cur_group*4 + 1;    //starting nav btn to show
        $("#nav_buttons .navbtn").hide();
        $("#nav_buttons .navbtn:nth-child(n+" + i + "):nth-child(-n+" + (i+3) + ")").css("display", "table");   //show 4 nav btns
	});



	//load small status bar progress bars
	$("#sb_progressbar_0").progressbar({
		value: 0
	});
	$("#sb_progressbar_1").progressbar({
		value: 0
	});
	$("#sb_progressbar_2").progressbar({
		value: 0
	});
	$("#sb_progressbar_3").progressbar({
		value: 0
	});
	$("#sb_progressbar_4").progressbar({
		value: 0
	});


	//handle switching between screens
	$("#navbtn_clone").mousedown(function() {
		switchToOperation(OP_CLONE);
	});
	$("#navbtn_hash").mousedown(function() {
		switchToOperation(OP_HASH);
	});
	$("#navbtn_wipe").mousedown(function() {
		switchToOperation(OP_WIPE);
	});
	$("#navbtn_push").mousedown(function() {
		switchToOperation(OP_PUSH);
	});
	$("#navbtn_task_macro").mousedown(function() {
		switchToOperation(OP_TASK_MACRO);
	});
	$("#navbtn_usb_device").mousedown(function() {
		switchToOperation(OP_USB_DEVICE);
	});
	$("#navbtn_logs").mousedown(function() {
		switchToOperation(OP_LOGS);
	});
	$("#navbtn_stats").mousedown(function() {
		switchToOperation(OP_STATS);
	});
	$("#navbtn_manage_repos").mousedown(function() {
		switchToOperation(OP_MANAGE_REPOS);
	});
	$("#navbtn_settings").mousedown(function() {
		switchToOperation(OP_SETTINGS);
	});
	$("#navbtn_network_settings").mousedown(function() {
		switchToOperation(OP_NETWORK_SETTINGS);
	});
	$("#navbtn_software").mousedown(function() {
		switchToOperation(OP_SOFTWARE);
	});
	$("#navbtn_restart").mousedown(function() {
		switchToOperation(OP_RESTART);
	});
	$("#navbtn_drives").mousedown(function() {
		switchToOperation(OP_DRIVES);
	});
	$("#navbtn_file_browser").mousedown(function() {
		switchToOperation(OP_FILE_BROWSER);
	});


    //set up initial display, disable and lock
    if (!changing_language) {
        scaleToScreenWidth();
        disableGUI();
        setCookie('unlocked', '0', 0);	//delete cookie so system is locked on startup
        lockGUI();
    }
    initGlobals();      //initGlobals and SetVersion need to be called again when language changed
    SetVersion(4);      //SetVersion is first server call, next server call is made on callback so it's
                        //sequential (since it depends on the success of this call)

	//Auto Zoom
	//scale site to browser width on resize timeout
	$(window).resize(function() {
		if(this.resizeTO) clearTimeout(this.resizeTO);
		this.resizeTO = setTimeout(function() {
			$(this).trigger('resizeEnd');
		}, 500);
	});

	$(window).bind('resizeEnd', function() {
		scaleToScreenWidth();

        //need to adjust File Browser iframe heights if screen changes size
        adjustFileBrowserIframeSize();
    });
	function scaleToScreenWidth() {
		var screen_width = $(window).width() - 11;	//the -11 keeps the scrollbar from showing up in Chrome, not sure why
		var screen_height = $(window).height() - 11;
		//console.log("Width: " + $(window).width() + " Height: * " + $(window).height());

		if (($(window).width() == 1009) && ($(window).height() == 585)) {
			//ugly hack for the Falcon native screen to remove the black border in the bottom and right hand side
			screen_width = 1024;
			screen_height = 600;
		}
		else if (($(window).width() == 785) && ($(window).height() == 465)) {
			//ugly hack for the ZXi native screen to remove the black border in the bottom and right hand side
			screen_width = 800;
			screen_height = 480;
		}
		//console.log("Screen Width: " + screen_width + " Screen Height: " + screen_height);

		var scale = Math.min(screen_width/1280, screen_height/720);	//scale by width or height

  		if (navigator.userAgent.match(/Firefox/i)) var bgsize = 1280*scale + "px";	//for FF, scale bg
		else var bgsize = "1280px";	//for Chrome

		$("body").css({"zoom": (100*scale) + "%", "background-size": bgsize,
			"-moz-transform": "scale(" + scale + ")"});	//FF CSS attribute

		//if (screen_width < 1280) {	//for no up-scaling
		//}
		//else {
		//	$("body").css({"zoom": "100%", "background-size": "1280px", "-moz-transform": "scale(1.0), translate(0px)"});
		//}
	}
});
