/* vim: set filetype=javascript: */
/* JS to do after everything else */
function loadLastJS() {
	/* remove title from dialog close button for touch screen */
	$(".ui-dialog .ui-dialog-titlebar-close").removeAttr('title');

    /* fix font-size adjusted modal titles */
    $(".ui-dialog-title").each(function() {
        if ($(this).html() != $(this).text()) $(this).html($(this).text());
    });

	/* Custom Scrollbars */
	$(".mcs_content").mCustomScrollbar({contentTouchScroll: true, scrollInertia: 300, scrollButtons: {enable: true, scrollType: "pixels", scrollAmount: 300}, advanced: {updateOnContentResize: true}});

	/* Disable Image Dragging */
	$('img').bind('dragstart', function(event) { event.preventDefault(); });
	$('a.scrollUpBtn').bind('dragstart', function(event) { event.preventDefault(); });
	$('a.scrollDownBtn').bind('dragstart', function(event) { event.preventDefault(); });
	
	/* Set up QWERTY keyboards */
	//to use set keyboard div class="qwerty_keyboard" and id="SOMETHING_keyboard", and set the text input id="SOMETHING_val"
	<?php
	$keystr = t("KEYBOARD_QWERTY");
    $intlstr = t("KEYBOARD_QWERTY_1");  //international keyboard
	$qk_html = "";
	for ($i=0; $i<19; $i++) {
		$key = $keystr[$i];
		$qk_html .= "<div id=\"qk" . $i . "\">" . $key . "</div>";
	}
	$qk_html .= "<div id=\"qkshift\">" . t("KEYBOARD_SHIFT") . "</div>";
	for ($i=19; $i<strlen($keystr); $i++) {
		$key = $keystr[$i];
		$qk_html .= "<div id=\"qk" . $i . "\">" . $key . "</div>";
	}
	$qk_html .= "<div id=\"qkdel\">" . t("KEYBOARD_DELETE") . "</div>";
    if ($intlstr == "" || $intlstr == "KEYBOARD_QWERTY_1") {    //if no international keyboards, no Globe button
        $qk_html .= "<div id=\"qkabc\">" . t("KEYBOARD_123") . "</div>";
        $qk_html .= "<div id=\"qkglobe\" style=\"display: none\"></div>";
    }
    else {  //otherwise show smaller ABC/123 button and Globe button
        $qk_html .= "<div id=\"qkabc\" class=\"smaller\">" . t("KEYBOARD_123") . "</div>";
        $qk_html .= "<div id=\"qkglobe\"></div>";
    }
	$qk_html .= "<div id=\"qkspace\">" . t("KEYBOARD_SPACE") . "</div>";
	?>
	$(".qwerty_keyboard").html('<?php print $qk_html; ?>');
    <?php 
    print "var keyboard_qwerty = \"" . str_replace('"', '\"', t("KEYBOARD_QWERTY")) . "\";\n";
    print "var keyboard_qwerty_shift = \"" . str_replace('"', '\"', t("KEYBOARD_QWERTY_SHIFT")) . "\";\n";
    print "var keyboard_123456 = \"" . str_replace('"', '\"', t("KEYBOARD_123456")) . "\";\n";
    print "var keyboard_123456_shift = \"" . str_replace('"', '\"', t("KEYBOARD_123456_SHIFT")) . "\";\n";
    print "var keyboard_abc = \"" . str_replace('"', '\"', t("KEYBOARD_ABC")) . "\";\n";
    print "var keyboard_123 = \"" . str_replace('"', '\"', t("KEYBOARD_123")) . "\";\n";
    $i = 1;
    while (t("KEYBOARD_QWERTY_" . $i) != "KEYBOARD_QWERTY_" . $i) {
        print "var keyboard_qwerty_" . $i . " = \"" . str_replace('"', '\"', t("KEYBOARD_QWERTY_" . $i)) . "\";\n";
        print "var keyboard_qwerty_" . $i . "_shift = \"" . str_replace('"', '\"', t("KEYBOARD_QWERTY_" . $i . "_SHIFT")) . "\";\n";
        print "var keyboard_qwerty_" . $i . "_abc = \"" . str_replace('"', '\"', t("KEYBOARD_QWERTY_" . $i . "_ABC")) . "\";\n";
        $i++;
    }
    print "var num_intl_keyboards = " . --$i . ";\n";
    ?>

    //handle Globe key
    $(".qwerty_keyboard div#qkglobe").click(function(event) {
		$(".qwerty_keyboard div#qkglobe").toggleClass("on");  //use $(".qwerty_keyboard") instead of $(this) so all keyboards' SHIFT/ABC/Globe stay in sync 
        if ($(this).hasClass("on")) {
            if (num_intl_keyboards == 1) var n = 1;
            else var n = 2;
            $(".qwerty_keyboard div#qkglobe").parent().find("div#qkabc").html(eval("keyboard_qwerty_" + n + "_abc"));
        }
        else $(".qwerty_keyboard div#qkglobe").parent().find("div#qkabc").html(keyboard_123);    //if switching back to English keyboard, 
                                                                    //reset to ABC keyboard (123 key showing)
        updateKeyboard();
        event.stopImmediatePropagation();	//keep general $("#clone_case_info_keyboard div").mousedown from firing
    });

    //handle ABC/123 key
	$(".qwerty_keyboard div#qkabc").click(function(event) {
        var intl = $(this).parent().find("div#qkglobe").hasClass("on");    //Globe button pressed
        var abc = $(this).parent().find("div#qkabc").html();               //which ABC/123 keyboard
        var newabc = keyboard_123;
        if (intl) { //cycle through int'l keys
            for (var i=1; i<=num_intl_keyboards; i++) {
                if (abc == eval("keyboard_qwerty_" + i + "_abc")) {
                    if (i+1 > num_intl_keyboards) var n = 1;
                    else var n = i+1;
                    newabc = eval("keyboard_qwerty_" + n + "_abc");
                }
            }
        }
        else {  //switch between ABC/123 keys
            if (abc == keyboard_123) newabc = keyboard_abc;
            else newabc = keyboard_123;
        }
        $(".qwerty_keyboard div#qkabc").html(newabc);  //use $(".qwerty_keyboard") instead of $(this) so all keyboards' SHIFT/ABC/Globe stay in sync 
        updateKeyboard();
		event.stopImmediatePropagation();	//keep general $("#clone_case_info_keyboard div").mousedown from firing
	});

	//handle shift and unshift
	$(".qwerty_keyboard div#qkshift").click(function(event) {
		$(".qwerty_keyboard div#qkshift").toggleClass("on");  //use $(".qwerty_keyboard") instead of $(this) so all keyboards' SHIFT/ABC/Globe stay in sync 
        updateKeyboard();
		event.stopImmediatePropagation();	//keep general $("#clone_case_info_keyboard div").mousedown from firing
	});

    function updateKeyboard() {
        var keyboard = $(".qwerty_keyboard");
        var intl = keyboard.find("div#qkglobe").hasClass("on");    //Globe button pressed
        var shift = keyboard.find("div#qkshift").hasClass("on");   //SHIFT button pressed
        var abc = keyboard.find("div#qkabc").html();               //which ABC/123 keyboard
        var keystr = keyboard_qwerty;
        if (intl) {
            var i = 1;
            for (var i=1; i<=num_intl_keyboards; i++) {
                if (abc == eval("keyboard_qwerty_" + i + "_abc")) {
                    if (i == 1) var n = num_intl_keyboards;
                    else var n = i-1;
                    if (shift) keystr = eval("keyboard_qwerty_" + n + "_shift");
                    else keystr = eval("keyboard_qwerty_" + n);

                    if (typeof(case_info_val_hangulIM) != "undefined") {    //if Korean, enable Hangul IM for Korean keyboard, disable otherwise
                        if (n == 1) enableHangulIM();
                        else disableHangulIM();
                    }
                }
            }
        }
        else {
            if (abc == keyboard_abc){
                if (shift)
		    keystr = keyboard_123456_shift;
                else
		    keystr = keyboard_123456;
            }
            else if (shift) keystr = keyboard_qwerty_shift;
            else keystr = keyboard_qwerty;

            if (typeof(case_info_val_hangulIM) != "undefined") {    //if Korean, enable Hangul IM for Korean keyboard, disable otherwise
                disableHangulIM();
            }
        }
		for (var i=0; i< 26; i++) {
            var newkey = (keystr.length > i ? keystr[i] : "");
			keyboard.find("#qk" + i).html(newkey);
		}
    }

    //enable/disable Hangul IM for Korean keyboard
    function enableHangulIM() {
        $(".qwerty_val").each(function() {
            eval($(this).attr("id") + "_hangulIM.enable();");
        });
    }
    function disableHangulIM() {
        $(".qwerty_val").each(function() {
            eval($(this).attr("id") + "_hangulIM.disable();");
        });
    }

	//handle keyboard keys
	var qwerty_val = "";	//the input box to update, handle multiple input boxes for one keyboard
	$(".qwerty_val").focus(function() {
		qwerty_val = $(this).attr("id");
	});

    $(".qwerty_keyboard div").mousedown(function() {   //set JS_IM.usingOnscreenKeyboard = true, so input buffer is saved while using onscreen keyboard
        if (typeof(case_info_val_hangulIM) != "undefined" && $(this).attr("id") != "qkdel" && $(this).attr("id") != "qkspace") {    //check for Korean keyboard, don't apply to Delete key or Space key
            $possible_vals = $(this).parent().prev().find(".qwerty_val");
            if ($possible_vals.length == 1) qwerty_val = $possible_vals[0].id;
            else if (qwerty_val == "") qwerty_val = $possible_vals[0].id;
            eval(qwerty_val + "_hangulIM.usingOnscreenKeyboard = true;");
        }
    });
    $(".qwerty_keyboard div").mouseup(function() {   //set JS_IM.usingOnscreenKeyboard = false
        if (typeof(case_info_val_hangulIM) != "undefined") {    //check for Korean keyboard
            $possible_vals = $(this).parent().prev().find(".qwerty_val");
            if ($possible_vals.length == 1) qwerty_val = $possible_vals[0].id;
            else if (qwerty_val == "") qwerty_val = $possible_vals[0].id;
            eval(qwerty_val + "_hangulIM.usingOnscreenKeyboard = false;");
        }
    });

	$(".qwerty_keyboard div").click(function() {
		$possible_vals = $(this).parent().prev().find(".qwerty_val");
		if ($possible_vals.length == 1) qwerty_val = $possible_vals[0].id;
		else if (qwerty_val == "") qwerty_val = $possible_vals[0].id;		

		var cursor_position = $("#" + qwerty_val).getCursorPosition();		//insert the character at the cursor
		var val = $("#" + qwerty_val).val();
		var val1 = val.substring(0, cursor_position);
		var val2 = val.substring(cursor_position, val.length);
		var clicked_id = $(this).attr("id");
		if (clicked_id == "qkdel") {
			val = val1.substring(0, val1.length-1) + val2;
			cursor_position = Math.max(cursor_position-1, 0);
            $("#" + qwerty_val).val(val);
            $("#" + qwerty_val).focus();	//this needs to happen within click or mouseup, not mousedown
		}
		else if (val.length < $("#" + qwerty_val).attr("maxlength")+1) {  //allow one more in case Korean character combines
            if (typeof(case_info_val_hangulIM) != "undefined" && case_info_val_hangulIM.isEnabled && clicked_id != "qkshift" && clicked_id != "qkabc" && clicked_id != "qkglobe" && clicked_id != "qkspace") {  //Hangul library doing weird things with Space and Shift+Space, so don't use it
                //trigger keydown for Korean characters Hangul IM
                var e = jQuery.Event("keydown");
                var i = clicked_id.replace("qk", "");
                if (clicked_id == "qkspace") e.keyCode = 32;
                else e.keyCode = keyboard_qwerty_shift[i].charCodeAt(0); //keycode in same as capital QWERTY letter
                e.shiftKey = $(this).parent().find("div#qkshift").hasClass("on");
                e.ctrlKey = false;
                e.altKey = false;
                e.metaKey = false;

                $("#" + qwerty_val).focus();	//this needs to happen within click or mouseup, not mousedown
                $("#" + qwerty_val).trigger(e);
                if ($("#" + qwerty_val).val().length > val.length) cursor_position++;   //if no combining
            }
            else if (val.length < $("#" + qwerty_val).attr("maxlength")) {
                if (clicked_id == "qkspace") val = val1 + " " + val2;
                else {
                    val = val1 + ($(this).parent().find("div#qkshift").hasClass("on") ? $(this).text().toUpperCase() : $(this).text().toLowerCase()) + val2;
                }
                cursor_position++;
                $("#" + qwerty_val).val(val);
                $("#" + qwerty_val).focus();	//this needs to happen within click or mouseup, not mousedown
            }
        }

        $("#" + qwerty_val).selectRange(cursor_position);

    });
}


//get cursor position in input or textarea
(function ($, undefined) {
    $.fn.getCursorPosition = function() {
        var el = $(this).get(0);
        var pos = 0;
        if('selectionStart' in el) {
            pos = el.selectionStart;
        } else if('selection' in document) {
            el.focus();
            var Sel = document.selection.createRange();
            var SelLength = document.selection.createRange().text.length;
            Sel.moveStart('character', -el.value.length);
            pos = Sel.text.length - SelLength;
        }
        return pos;
    }
})(jQuery);

//$('#elem').selectRange(3,5); // select a range of text
//$('#elem').selectRange(3); // set cursor position
$.fn.selectRange = function(start, end) {
    if(!end) end = start; 
    return this.each(function() {
        if (this.setSelectionRange) {
            this.focus();
            this.setSelectionRange(start, end);
        } else if (this.createTextRange) {
            var range = this.createTextRange();
            range.collapse(true);
            range.moveEnd('character', end);
            range.moveStart('character', start);
            range.select();
        }
    });
};
