/* vim: set filetype=javascript: */
function loadManageReposJS() {

    //------------------------------------------------------------
	// SET UP TABS
	//------------------------------------------------------------
	//set up tabs
	$("#manage_repos_tab_0").mousedown(function() { selectNonTaskTab(0); });
	$("#manage_repos_tab_1").mousedown(function() { selectNonTaskTab(1); });
	$("#manage_repos_tab_2").mousedown(function() { selectNonTaskTab(2); });

    <?php if ($LOGICUBE_PLATFORM == "zxiforensic"): ?>
    disableObj($("#repo_network_source_block"));
    disableObj($("#repo_network_destination_block"));
    <?php else: ?>
    disableObj($("#repo_network_block"));
    <?php endif; ?>

	/* Add/Remove */
	//unhighlight current selection, highlight new selection, only one selection allowed
	//if the one selected is clicked, unselect
    $("#manage_repos_select").unbind("mousedown");
	$("#manage_repos_select").on("mousedown", ".select-opt", function() {
		var cur_repo = $(this).find(".col1").html();
		if ($(this).hasClass("ui-state-disabled")) {
			//do not select disabled
		}
		else {
			var sel_repo = "";
			$("#manage_repos_select .select-opt").each(function() {
				if ($(this).hasClass("ui-selected")) {
					sel_repo = $(this).find(".col1").text();
					$(this).toggleClass("ui-selected");
				}
			});
			
			if (cur_repo != sel_repo) {
				$(this).toggleClass("ui-selected");
			}
		}
	});

	//edit repo buttons
	$("#manage_repos_select").on("mousedown", ".edit-repo", function() {
		if ($(this).attr('disabled') != 'disabled') {										//need to handle lock-button functionality here, because edit-repo rows are dynamically generated
			if (systemLocked() && !$(this).hasClass('key_validated')) {						//lock-button mousedown doesn't use "live"/"on" for dynamically generated content, because that
				event.stopImmediatePropagation();	//stop events in same node from firing	//doesn't work with event.stopImmediatePropagation
				passkey_config['Callback'] = $(this).attr('id');
				$("#settings_unlock_dialog").dialog('option', 'title', "<?= t("ENTER_KEY_TO_UNLOCK"); ?>");
				$("#settings_unlock_dialog").dialog('open');
			}
			else {
				$(this).removeClass('key_validated');

                //populate Add Repo dialog with selected repo info and open
                var sel_repo = repoWithName($(this).parent().find(".col1").text());
                add_repo_config = {Name: sel_repo['Name'], Location: sel_repo['Location'], Path: sel_repo['Path'], Domain: sel_repo['Domain'], Username: sel_repo['Username'], Password: sel_repo['Password'], Role: $.inArray(sel_repo['Role'], APIREPOROLES), InterfaceName: sel_repo['InterfaceName']};

                $("#repo_name_block_content").html(add_repo_config['Name']);
				$("#repo_drive_block_content").html(add_repo_config['Location'] == "Network" ? "Network Share" : "");
                $("#repo_drives_select .select-opt").each(function() {
				    if (($(this).find(".col1").text() == "Network Share" && add_repo_config['Location'] == "Network") || ($(this).find(".col1").text() == add_repo_config['Location'])) {
                        $(this).addClass("ui-selected");
                    }
				});
                <?php if ($LOGICUBE_PLATFORM == "zxiforensic"): ?>
                var interface = add_repo_config['InterfaceName'];
                if (interface == "") interface = "<?php t("ANY"); ?>";
                $("#repo_network_source_block_content").html(interface);
				if (add_repo_config['Location'] == "Network") {
                    enableObj($("#repo_network_source_block"));
                    enableObj($("#repo_network_destination_block"));
                }
				else {
                    disableObj($("#repo_network_source_block"));
                    disableObj($("#repo_network_destination_block"));
                }
                <?php else: ?>
				if (add_repo_config['Location'] == "Network") enableObj($("#repo_network_block"));
				else disableObj($("#repo_network_block"));
                <?php endif; ?>

                var network_info = "<?= t("PATH"); ?>: " + add_repo_config['Path'] + ", <?= t("DOMAIN"); ?>: " + add_repo_config['Domain'] + 
					", <?= t("USERNAME"); ?>: " + add_repo_config['Username'] + ", <?= t("PASSWORD"); ?>: " + (add_repo_config['Password'] == "" ? "" : "<?= t("PASSWORD_SET"); ?>");
				if (network_info.length > 64) network_info = network_info.substr(0, 64) + "...";
                <?php if ($LOGICUBE_PLATFORM == "zxiforensic"): ?>
				$("#repo_network_destination_block_content").html(network_info);
                <?php else: ?>
				$("#repo_network_block_content").html(network_info);
                <?php endif; ?>
				$("#repo_role_block_content").html(REPOROLES[add_repo_config['Role']]);
                $("#repo_role_" + add_repo_config['Role']).mousedown();

                $("#manage_repos_add_dialog").data('editing_repo', true).dialog('open');
			}
		}

	});


	//delete repo buttons
	$("#manage_repos_select").on("mousedown", ".delete-repo", function() {
		if ($(this).attr('disabled') != 'disabled') {										//need to handle lock-button functionality here, because delete-repo rows are dynamically generated
			if (systemLocked() && !$(this).hasClass('key_validated')) {						//lock-button mousedown doesn't use "live"/"on" for dynamically generated content, because that
				event.stopImmediatePropagation();	//stop events in same node from firing	//doesn't work with event.stopImmediatePropagation
				passkey_config['Callback'] = $(this).attr('id');
				$("#settings_unlock_dialog").dialog('option', 'title', "<?= t("ENTER_KEY_TO_UNLOCK"); ?>");
				$("#settings_unlock_dialog").dialog('open');
			}
			else {
				$(this).removeClass('key_validated');

				var repo_name = $(this).parent().find(".col1").text();
				var info = "<?= t("DELETE_REPOSITORY_N_ARE_YOU_SURE"); ?>";
				info = info.replace("%1", repo_name);
				$("#manage_repos_delete_dialog").html(info);
				$("#manage_repos_delete_dialog").data('repo_name', repo_name);
				$("#manage_repos_delete_dialog").dialog('open');
			}
		}

	});

	//more info buttons
	$("#manage_repos_select").on("mousedown", ".edit-files", function() {
		if (!$(this).hasClass('ui-state-disabled')) {		//'click' isn't automically disabled for DIVs
            var repo_name = $(this).parent().find(".col1").text();
            RepositoryListContents(repo_name);
            var dialog_title = "<?= t("REPOSITORY_NAME_N"); ?>";
            dialog_title = dialog_title.replace("%1", repo_name);
            $("#manage_repos_files_dialog").dialog({title: dialog_title}).data('repo_name', repo_name).dialog('open');
        }
	});

	//set up manage_repos_files_dialog dialog
	$("#manage_repos_files_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
			//do nothing
		}
	});


	//unhighlight current selection, highlight new selection, only one selection allowed
	//if the one selected is clicked, unselect
    $("#manage_repos_files_select").unbind("mousedown");
	$("#manage_repos_files_select").on("mousedown", ".select-opt", function() {
		if ($(this).hasClass("ui-state-disabled")) {
			//do not select disabled
		}
		else {
			var cur_file = $(this).find(".col2").text();
			var sel_file = "";
			$("#manage_repos_files_select .select-opt").each(function() {
				if ($(this).hasClass("ui-selected")) {
					sel_file = $(this).find(".col2").text();
					$(this).toggleClass("ui-selected");
				}
			});
			
			if (cur_file != sel_file) {
				$(this).toggleClass("ui-selected");
			}
			if ($(this).hasClass("ui-selected")) enableObj($("#manage_repos_files_delete_btn"));
			else disableObj($("#manage_repos_files_delete_btn"));
		}
	});

	//set up Delete button
	$("#manage_repos_files_delete_btn").mousedown(function() {
		$("#manage_repos_files_select .select-opt").each(function() {
			$("#manage_repos_files_delete_dialog").dialog('open');
			if ($(this).hasClass("ui-selected")) {
				var sel_file = $(this).find(".col2").text();
				var info = "<?= t("DELETE_SELECTED_FILE_N_ARE_YOU_SURE"); ?><br/><br/><?= t("SELECTED_FILE_WILL_BE_PERMANENTLY_DELETED"); ?>";
				info = info.replace("%1", '<span id="manage_repos_files_sel_file">' + sel_file + '</span>');
				$('#manage_repos_files_dialog').data('opening_another_dialog', true).dialog('close');
				$("#manage_repos_files_delete_dialog").html(info).dialog('open');
			}
		});
	});
	//set up manage_repos_files_delete_dialog
	$("#manage_repos_files_delete_dialog").dialog({
		dialogClass: 'ui-conf-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				$(this).dialog('close');
				var repo_file_params = {'Repository': $("#manage_repos_files_dialog").data('repo_name'), 'Name': $("#manage_repos_files_sel_file").text()};
				ImageDelete(repo_file_params);
				RepositoryListContents($("#manage_repos_files_dialog").data('repo_name'));
				$('#manage_repos_files_dialog').dialog('open');
			}
		},
		close: function(event, ui) {
			$('#manage_repos_files_dialog').dialog('open');
		}
	});
	//set up Delete All button
	$("#manage_repos_files_delete_all_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#manage_repos_files_dialog').data('opening_another_dialog', true).dialog('close');
			$("#manage_repos_files_delete_all_dialog").dialog('open');	
		}
	});
	//set up manage_repos_files_delete_all_dialog
	$("#manage_repos_files_delete_all_dialog").dialog({
		dialogClass: 'ui-conf-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				$(this).dialog('close');
				ImageDeleteAll($("#manage_repos_files_dialog").data('repo_name'));
				RepositoryListContents($("#manage_repos_files_dialog").data('repo_name'));
				$('#manage_repos_files_dialog').dialog('open');
			}
		},
		close: function(event, ui) {
			$('#manage_repos_files_dialog').dialog('open');
		}
	});


	//set up manage_repos_delete_dialog confirmation dialog
	$("#manage_repos_delete_dialog").dialog({
		dialogClass: 'ui-conf-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		buttons: {
			'YES': function() {
				$(this).dialog('close');
				var repo_name = $("#manage_repos_delete_dialog").data('repo_name');
				RepositoryRemove(repo_name);
			}
		}
	});

	$("#manage_repos_add_btn").mousedown(function() {
		$('#manage_repos_add_dialog').data('editing_repo', false).dialog('open');
	});
	//set up manage_repos_add_dialog
	$("#manage_repos_add_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
                $(this).data('ok_clicked', true);
				$(this).dialog('close');
				RepositoryAdd(add_repo_config);
			}
		},
		close: function(event, ui) {
            //if user cancels out of editing, clear fields (if cancelling out of adding repo, retain data)
			if ($(this).data('editing_repo') === true && $(this).data('opening_another_dialog') === false && $(this).data('ok_clicked') === false) clearAddRepoConfig();
        }
	});

	$("#repo_name_block").mousedown(function() {
		$('#manage_repos_add_dialog').data('opening_another_dialog', true).dialog('close');
		$("#repo_name_val").val(add_repo_config['Name']);
		$('#repo_name_dialog').dialog('open');
	});
	//set up repo_name_dialog
	$("#repo_name_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				add_repo_config['Name'] = $("#repo_name_val").val();
				$("#repo_name_block_content").html(add_repo_config['Name']);
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
			resetKeyboard("repo_name");
			$('#manage_repos_add_dialog').dialog('open');
		}
	});
	//unhighlight current selection, highlight new selection, only one selection allowed
	//if the one selected is clicked, unselect
    $("#repo_drives_select").unbind("mousedown");
	$("#repo_drives_select").on("mousedown", ".select-opt", function() {
		var cur_drive = $(this).find(".col1").text();
		if ($(this).hasClass("ui-state-disabled")) {
			//do not select disabled
		}
		else {
			var sel_drive = "";
			$("#repo_drives_select .select-opt").each(function() {
				if ($(this).hasClass("ui-selected")) {
					sel_drive = $(this).find(".col1").text();
					$(this).toggleClass("ui-selected");
				}
			});
	
			if (cur_drive != sel_drive) {
				$(this).toggleClass("ui-selected");
			}
		}
	});


	$("#repo_drive_block").mousedown(function() {
		$('#manage_repos_add_dialog').data('opening_another_dialog', true).dialog('close');
		$('#repo_drive_dialog').dialog('open');
	});
	//set up repo_drive_dialog
	$("#repo_drive_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				add_repo_config['Bay'] = "";
				add_repo_config['PartitionNumber'] = "";
				add_repo_config['Location'] = "Bay";
				var drive_info = "";
				$("#repo_drives_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) {
						add_repo_config['Bay'] = $(this).find("td.col1 .bay").html();
						add_repo_config['PartitionNumber'] = parseInt($(this).find("td.col1 .partition").text());
						if ($(this).find("td.col1 .bay").html() == "Network Share") add_repo_config['Location'] = "Network";
						drive_info = $(this).find("td.col1").text();
						return false;	//exit 'each' loop
					}
				});

                <?php if ($LOGICUBE_PLATFORM == "zxiforensic"): ?>
				if (add_repo_config['Location'] == "Network") {
                    enableObj($("#repo_network_source_block"));
                    enableObj($("#repo_network_destination_block"));
                }
				else {
                    disableObj($("#repo_network_source_block"));
                    disableObj($("#repo_network_destination_block"));
                }
                <?php else: ?>
				if (add_repo_config['Location'] == "Network") enableObj($("#repo_network_block"));
				else disableObj($("#repo_network_block"));
                <?php endif; ?>

                $("#repo_drive_block_content").html(drive_info);
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
			$('#manage_repos_add_dialog').dialog('open');
		}
	});

    <?php if ($LOGICUBE_PLATFORM == "zxiforensic"): ?>
	$("#repo_network_destination_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#manage_repos_add_dialog').data('opening_another_dialog', true).dialog('close');
			$("#repo_network_path_val").val(add_repo_config['Path']);
			$("#repo_network_domain_val").val(add_repo_config['Domain']);
			$("#repo_network_username_val").val(add_repo_config['Username']);
			$("#repo_network_password_val").val(add_repo_config['Password']);
			$('#repo_network_keyboard_dialog').dialog('open');
		}
	});
	$("#repo_network_source_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
            GetNWInterfaceList();
            //dialog opened on callback
        }
	});
	//set up repo_network_source_dialog
	$("#repo_network_source_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				add_repo_config['InterfaceName'] = "";
				$("#repo_network_source_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) {
                        add_repo_config['InterfaceName'] = $(this).find(".col1").html();
						return false;	//exit 'each' loop
					}
				});

                $("#repo_network_source_block_content").html(add_repo_config['InterfaceName']);
                if (add_repo_config['InterfaceName'] == "<?= t("ANY"); ?>") add_repo_config['InterfaceName'] = "";
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
			$('#manage_repos_add_dialog').dialog('open');
		}
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
	//if the one selected is clicked, unselect
    $("#repo_network_source_select").unbind("mousedown");
	$("#repo_network_source_select").on("mousedown", ".select-opt", function() {
		var cur_source = $(this).find(".col1").html();
		if ($(this).hasClass("ui-state-disabled")) {
			//do not select disabled
		}
		else {
			var sel_source = "";
			$("#repo_network_source_select .select-opt").each(function() {
				if ($(this).hasClass("ui-selected")) {
					sel_source = $(this).find(".col1").text();
					$(this).toggleClass("ui-selected");
				}
			});
			
			if (cur_source != sel_source) {
				$(this).toggleClass("ui-selected");
			}
		}
	});

    <?php else: ?>
	$("#repo_network_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#manage_repos_add_dialog').data('opening_another_dialog', true).dialog('close');
			$("#repo_network_path_val").val(add_repo_config['Path']);
			$("#repo_network_domain_val").val(add_repo_config['Domain']);
			$("#repo_network_username_val").val(add_repo_config['Username']);
			$("#repo_network_password_val").val(add_repo_config['Password']);
			$('#repo_network_keyboard_dialog').dialog('open');
		}
	});
    <?php endif; ?>
	//set up repo_network_keyboard_dialog
	$("#repo_network_keyboard_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				add_repo_config['Path'] = $("#repo_network_path_val").val();
				add_repo_config['Domain'] = $("#repo_network_domain_val").val();
				add_repo_config['Username'] = $("#repo_network_username_val").val();
				add_repo_config['Password'] = $("#repo_network_password_val").val();
				var network_info = "<?= t("PATH"); ?>: " + add_repo_config['Path'] + ", <?= t("DOMAIN"); ?>: " + add_repo_config['Domain'] + 
					", <?= t("USERNAME"); ?>: " + add_repo_config['Username'] + ", <?= t("PASSWORD"); ?>: " + (add_repo_config['Password'] == "" ? "" : "<?= t("PASSWORD_SET"); ?>");
				if (network_info.length > 64) network_info = network_info.substr(0, 64) + "...";
                <?php if ($LOGICUBE_PLATFORM == "zxiforensic"): ?>
				$("#repo_network_destination_block_content").html(network_info);
                <?php else: ?>
				$("#repo_network_block_content").html(network_info);
                <?php endif; ?>
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
			$('#manage_repos_add_dialog').dialog('open');
		}
	});

	$("#repo_role_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#manage_repos_add_dialog').data('opening_another_dialog', true).dialog('close');
			$('#repo_role_dialog').dialog('open');
		}
	});
	//set up repo_role_dialog
	$("#repo_role_dialog").dialog({
		dialogClass: 'ui-sm-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var repo_info = "";
				$("#repo_role_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) {
						add_repo_config['Role'] = i;
						repo_info = REPOROLES[add_repo_config['Role']];
						return false;
					}
				});
				$("#repo_role_block_content").html(repo_info);
				$(this).dialog('close');
				$('#manage_repos_add_dialog').dialog('open');
			}
		}
	});
	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#repo_role_select .select-opt").mousedown(function() {
		$("#repo_role_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});


	//disable OK button on Add Repo dialog until all necessary info it entered
	$("#manage_repos_add_dialog").bind("dialogopen", function() {
		checkAddRepoParams();
        $(this).data('opening_another_dialog', false);
        $(this).data('ok_clicked', false);
    });
	function checkAddRepoParams() {
		if ((add_repo_config['Name'] == "") || (add_repo_config['Location'] == "") || ((add_repo_config['Location'] == "Bay") && (add_repo_config['Bay'] == "")) ||
			((add_repo_config['Location'] == "Network") && (add_repo_config['Path'] == ""))) {
			$("#manage_repos_add_dialog").next(".ui-dialog-buttonpane").find("button").attr('disabled', 'disabled');	//disableObj function only handles ids
			$("#manage_repos_add_dialog").next(".ui-dialog-buttonpane").find("button").addClass('ui-state-disabled');
			return true;
			
		}
		$("#manage_repos_add_dialog").next(".ui-dialog-buttonpane").find("button").removeAttr('disabled');	//disableObj function only handles ids
		$("#manage_repos_add_dialog").next(".ui-dialog-buttonpane").find("button").removeClass('ui-state-disabled');
		return true;
	}

	/* iSCSI */
	$("#iscsi_network_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#iscsi_network_keyboard_dialog').dialog('open');
		}
	});
	//set up network_settings_server_keyboard_dialog
	$("#iscsi_network_keyboard_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				iscsi_config["Portal"] = $("#iscsi_portal_val").val();
				iscsi_config["Username"] = $("#iscsi_username_val").val();
				iscsi_config["Password"] = $("#iscsi_password_val").val();
				updateIscsiPage();
				$(this).dialog('close');
				DbIscsiConfig({'DbOpr': 6, 'id': 1, 'portal': iscsi_config["Portal"], 'iqn': iscsi_config["IQN"], 'username': iscsi_config["Username"], 'password': iscsi_config["Password"], 'role': APIREPOROLES[iscsi_config["Role"]]});
			}
		},
		close: function(event, ui) {
			updateIscsiPage();
			resetKeyboard("iscsi_network");
		}
	});

	$("#iscsi_role_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#iscsi_role_dialog').dialog('open');
		}
	});
	//set up iscsi_role_dialog
	$("#iscsi_role_dialog").dialog({
		dialogClass: 'ui-sm-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				$("#iscsi_role_select .select-opt").each(function(i) {
					if ($(this).hasClass("ui-selected")) {
						iscsi_config['Role'] = i;
						return false;
					}
				});
				updateIscsiPage();
				$(this).dialog('close');
				DbIscsiConfig({'DbOpr': 6, 'id': 1, 'portal': iscsi_config["Portal"], 'iqn': iscsi_config["IQN"], 'username': iscsi_config["Username"], 'password': iscsi_config["Password"], 'role': APIREPOROLES[iscsi_config["Role"]]});
			}
		}
	});
	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#iscsi_role_select .select-opt").mousedown(function() {
		$("#iscsi_role_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});
	
	$("#iscsi_connect").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
            var info = "<?= t("CONNECTING_TO_N"); ?>";
            info = info.replace("%1", iscsi_config['Portal']);
            $('#iscsi_connect_dialog').html(info);
            $("#iscsi_connect_dialog").next(".ui-dialog-buttonpane").find("button").attr('disabled', 'disabled');		//disable OK button
            $("#iscsi_connect_dialog").next(".ui-dialog-buttonpane").find("button").addClass('ui-state-disabled');
            $('#iscsi_connect_dialog').dialog('open');
            IscsiConnect({'Portal': iscsi_config["Portal"], 'IQN': iscsi_config["IQN"], 'Username': iscsi_config["Username"], 'Password': iscsi_config["Password"], 'Role': APIREPOROLES[iscsi_config["Role"]]});
        }
	});
	$("#iscsi_disconnect").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
            var info = "<?= t("DISCONNECTING_FROM_N"); ?>";
            info = info.replace("%1", iscsi_config['Portal']);
            $('#iscsi_connect_dialog').html(info);
            $("#iscsi_connect_dialog").next(".ui-dialog-buttonpane").find("button").attr('disabled', 'disabled');		//disable OK button
            $("#iscsi_connect_dialog").next(".ui-dialog-buttonpane").find("button").addClass('ui-state-disabled');
            $('#iscsi_connect_dialog').dialog('open');
            IscsiDisconnect({"Portal": iscsi_config['Portal']});
        }
    });

	//set up iSCSI confirmation dialog
	$("#iscsi_connect_dialog").dialog({
		dialogClass: 'ui-sm-dialog ui-sm-dialog-notitlebar',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				$(this).dialog('close');
			}
		}
	});

    /* Configuration */
	$("#config_file_system_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#config_file_system_dialog').dialog('open');
		}
	});
	//set up config_file_system_dialog
	$("#config_file_system_dialog").dialog({
		dialogClass: 'ui-sm-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				$("#config_file_system_dialog .select-opt").each(function(i) {
					if ($(this).hasClass("ui-selected")) {
						DEFAULT_FILESYSTEM = i;
						return false;
					}
				});
				updateDefaultFileSystem();
				$(this).dialog('close');
                SetConfiguration({"DefaultFilesystem": FILESYSTEMS[DEFAULT_FILESYSTEM]});
			}
		}
	});
	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#config_file_system_select .select-opt").mousedown(function() {
		$("#config_file_system_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});

	/* Format */
	/*
	//unhighlight current selection, highlight new selection, only one selection allowed
	//if the one selected is clicked, unselect
    $("#format_drives_select").unbind("mousedown");
	$("#format_drives_select").on("mousedown", ".select-opt td", function() {
        if ($(this).hasClass("select-more")) {
            var bay = $(this).parent().find(".col1").text();
            updateDriveDetails(bay);
            $('#clone_drive_details_dialog').dialog('open');
        }
        else {
            var cur_bay = $(this).find(".col1").html();
            if ($(this).parent().hasClass("ui-state-disabled")) {
                //do not select disabled
            }
            else {
                var sel_bay = "";
                $("#format_drives_select .select-opt").each(function() {
                    if ($(this).hasClass("ui-selected")) {
                        sel_bay = $(this).find(".col1").html();
                        $(this).toggleClass("ui-selected");
                        //$(this).find(".col3").html("<?= t("AVAILABLE"); ?>");
                    }
                });

                if (cur_bay != sel_bay) {
                    $(this).parent().toggleClass("ui-selected");
                    //$(this).parent().find(".col3").html("<?= t("SELECTED"); ?>");	//don't do this because periodic update will change to "Available"
                }
            }
}
	});

	//Format Drive button
	$("#format_drive_btn").mousedown(function() {
		$("#format_drives_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) {
				var bay = $(this).find(".col1").html();
				$("#format_drive_dialog").data('bay', bay);
				var info = "<?= t("FORMAT_DRIVE_N_ARE_YOU_SURE"); ?>";
				info = info.replace("%1", bay);
				info += "<br/><br/><div style=\"font-size: 0.7em\"><?= t("FORMATTING_WILL_ERASE_ALL_DATA"); ?></div>";
				$("#format_drive_dialog").html(info);
				$("#format_drive_dialog").dialog('open');
			}
		});
	});

	//confirmation dialog
	$("#format_drive_dialog").dialog({
		dialogClass: 'ui-conf-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		buttons: {
			'YES': function() {
				$(this).dialog('close');
				var bay = $("#format_drive_dialog").data('bay');
				RepositoryFormat({'Name': bay});
			}
		}
	});

	
	*/


	//reset data on dialog open/close
	$("#manage_repos_files_delete_dialog").bind("dialogopen", function() {
		$(this).data('opening_another_dialog', false);
	});
	$("#manage_repos_files_delete_dialog").bind("dialogclose", function() {
	});

}
