/* vim: set filetype=javascript: */
function loadNetworkSettingsJS() {

    //------------------------------------------------------------
	// SET UP TABS
	//------------------------------------------------------------
	//set up tabs
	$("#network_settings_tab_0").mousedown(function() { selectNonTaskTab(0); });
	$("#network_settings_tab_1").mousedown(function() { selectNonTaskTab(1); });
	$("#network_settings_tab_2").mousedown(function() { selectNonTaskTab(2); });

    /* Network Services */
    $("#network_services_enable_btn").mousedown(function() {
		if ($(this).hasClass("ui-state-disabled")) {
			//do not select disabled
		}
        else {
            var service = "";
            var state = "";
            $("#network_services_select .select-opt").each(function() {
                if ($(this).hasClass("ui-selected")) {
                    service = $(this).find(".col1").text();
					state = $(this).find(".col3").text();
                    if (state == "<?= t("ENABLED"); ?>") {
                        DbServicesConfig({'DbOpr': 6, 'name': service, 'allowed': false });
					}
					else {
                        DbServicesConfig({'DbOpr': 6, 'name': service, 'allowed': true });
					}
					return false; 	//only one allowed for now so exit loop
                }
            });
        }
    });

    //unhighlight current selection, highlight new selection, only one selection allowed
	//if a service is allowed, show Disable button, otherwise show Enable button
    $("#network_services_select").unbind("mousedown"); 
	$("#network_services_select").on("mousedown", ".select-opt td", function() {
        if ($(this).hasClass("ui-state-disabled")) {
            //do not select disabled
        }
        else {
            var cur_service = $(this).parent().find(".col1").text();
            var sel_service = "";
            var service_allowed = false;
            $("#network_services_select .select-opt").each(function() {
                if ($(this).hasClass("ui-selected")) {
                    sel_service = $(this).find(".col1").text();
                    $(this).toggleClass("ui-selected");
                }
            });

            if (cur_service != sel_service) {
                $(this).parent().toggleClass("ui-selected");
                if ($(this).parent().find(".col3").text() == "<?= t("ENABLED"); ?>") $("#network_services_enable_btn").text("<?= t("DISABLE_BTN"); ?>");
                else $("#network_services_enable_btn").text("<?= t("ENABLE_BTN"); ?>");
            }

            if ($(this).parent().hasClass("ui-selected")) enableObj($("#network_services_enable_btn"));
            else disableObj($("#network_services_enable_btn"));
        }
	});

    <?php if ($LOGICUBE_PLATFORM == "zxiforensic"): ?>
    /* Interfaces */
    //unhighlight current selection, highlight new selection, only one selection allowed
	//if a service is allowed, show Disable button, otherwise show Enable button
    $("#network_interfaces_select").unbind("mousedown"); 
	$("#network_interfaces_select").on("mousedown", ".select-opt td", function() {
        if ($(this).hasClass("ui-state-disabled")) {
            //do not select disabled
        }
        else {
            var cur_interface = $(this).parent().find(".col1").text();
            var sel_interface = "";
            $("#network_interfaces_select .select-opt").each(function() {
                if ($(this).hasClass("ui-selected")) {
                    sel_interface = $(this).find(".col1").text();
                    $(this).toggleClass("ui-selected");
                }
            });

            if (cur_interface != sel_interface) {
                $(this).parent().toggleClass("ui-selected");
            }

            if ($(this).parent().hasClass("ui-selected")) enableObj($("#network_interfaces_edit_config_btn"));
            else disableObj($("#network_interfaces_edit_config_btn"));
        }
    });


    $("#network_interfaces_edit_config_btn").mousedown(function() {
		if ($(this).hasClass("ui-state-disabled")) {
			//do not select disabled
		}
        else {
            $("#network_interfaces_select .select-opt").each(function() {
                if ($(this).hasClass("ui-selected")) {
                    var sel_interface = interfaceWithName($(this).find(".col1").text());
                    updateNWInterfaceModals(sel_interface);
                    var title = "<?= t("EDIT_NETWORK_INTERFACE_CONFIG_N"); ?>";
				    title = title.replace("%1", sel_interface['Name']);
                    $("#network_interfaces_edit_config_dialog").dialog('option', 'title', title).dialog('open');
                    return false;
                }
            });
        }
    });
	//set up network_interfaces_edit_config_dialog
	$("#network_interfaces_edit_config_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
                SetNWInterface(network_interface_config);
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
        }
	});


    //interface type
    $("#interface_type_block").mousedown(function() {
        $('#network_interfaces_edit_config_dialog').dialog('close');
        $('#interface_type_dialog').dialog('open');
	});
    //set up interface_type_dialog
	$("#interface_type_dialog").dialog({
		dialogClass: 'ui-sm-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var type = 0;
				$("#interface_type_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) {
                        type = i;
						return false;
					}
				});
                network_interface_config['Type'] = type;
                $("#interface_type_block_content").html(INTERFACETYPES[type]);
                if (type == INTERFACETYPE_DHCP) disableObj($("#interface_ip_block"));
                else enableObj($("#interface_ip_block"));
                enableDisableNWInterfaceOKButton();
                $(this).dialog('close');
                $('#network_interfaces_edit_config_dialog').dialog('open');
            }
		}
	});
	//unhighlight current selection, highlight new selection, only one selection allowed
    $("#interface_type_select").unbind("mousedown");
	$("#interface_type_select .select-opt").mousedown(function() {
		$("#interface_type_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});

    //interface ip settings
    $("#interface_ip_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
            $('#network_interfaces_edit_config_dialog').dialog('close');
            $('#interface_ip_dialog').dialog('open');
        }
	});
    //set up interface_ip_dialog
	$("#interface_ip_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
                var ipval0 = getIPNum($('#iv_ip0').val()); $('#iv_ip0').val(ipval0);
                var ipval1 = getIPNum($('#iv_ip1').val()); $('#iv_ip1').val(ipval1);
                var ipval2 = getIPNum($('#iv_ip2').val()); $('#iv_ip2').val(ipval2);
                var ipval3 = getIPNum($('#iv_ip3').val()); $('#iv_ip3').val(ipval3);
                var ipval = ipval0 + "." + ipval1 + "." + ipval2 + "." + ipval3;

                var netmaskval = getNetmaskNum($('#iv_netmask').val()); $('#iv_netmask').val(netmaskval);

                var gatewayval0 = getIPNum($('#iv_gateway0').val()); $('#iv_gateway0').val(gatewayval0);
                var gatewayval1 = getIPNum($('#iv_gateway1').val()); $('#iv_gateway1').val(gatewayval1);
                var gatewayval2 = getIPNum($('#iv_gateway2').val()); $('#iv_gateway2').val(gatewayval2);
                var gatewayval3 = getIPNum($('#iv_gateway3').val()); $('#iv_gateway3').val(gatewayval3);
                var gatewayval = gatewayval0 + "." + gatewayval1 + "." + gatewayval2 + "." + gatewayval3;
        
                var dnsval0 = getIPNum($('#iv_dns0').val()); $('#iv_dns0').val(dnsval0);
                var dnsval1 = getIPNum($('#iv_dns1').val()); $('#iv_dns1').val(dnsval1);
                var dnsval2 = getIPNum($('#iv_dns2').val()); $('#iv_dns2').val(dnsval2);
                var dnsval3 = getIPNum($('#iv_dns3').val()); $('#iv_dns3').val(dnsval3);
                var dnsval = dnsval0 + "." + dnsval1 + "." + dnsval2 + "." + dnsval3;

                network_interface_config['IPAddress'] = ipval;
                network_interface_config['NetMask'] = netmaskval;
                network_interface_config['Gateway'] = gatewayval;
                network_interface_config['NameServers'] = dnsval;

                var ipsettings = "<?= t("IP_NETMASK"); ?>: " + network_interface_config['IPAddress'] + "/" + network_interface_config['NetMask'] + ", " + "<?= t("GATEWAY"); ?>: " + network_interface_config['Gateway'] + ", " + "<?= t("DNS_SERVER"); ?>: " + network_interface_config['NameServers'];
                $("#interface_ip_block_content").html(ipsettings);

                enableDisableNWInterfaceOKButton();

                $(this).dialog('close');
                $('#network_interfaces_edit_config_dialog').dialog('open');
			}
		},
		close: function(event, ui) {
            $('#network_interfaces_edit_config_dialog').dialog('open');
        }
	});

	$focussed_iv = $("#iv_ip0");
	$first_iv = $("#interface_ip_boxes div:first-child input");
	$last_iv = $("#interface_dns_boxes div:last-child input");
	$("#interface_ip_enter input").blur(function() {
		$(this).parent("div").removeClass("focus");
	});
	$("#interface_ip_enter input").focus(function() {
		if ($("#interface_ip_enter").attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$(this).parent().addClass("focus");
			$(this).select();
			$focussed_iv = $(this);
		}
		else {
			$(this).blur();
		}
	});

	/* handle keyboard keys */
	$("#interface_ip_keys div").mouseup(function() {
		if ($("#interface_ip_keys").attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs

			if ($(this).attr("id") == "ikdel") {	//handle delete
                var origlen = $focussed_iv.val().length;
                var newval = $focussed_iv.val().slice(0, -1);   //delete last char
				$focussed_iv.val(newval);
                $focussed_iv.focus();
                if (origlen == 0) {     //if clicked delete on empty box, go to prev box
                    if ($focussed_iv.attr("id") == $first_iv.attr("id")) {
                        $focussed_iv.focus();
                    }
                    else if ($focussed_iv.attr("id") == "iv_netmask") {
                        $focussed_iv = $("#iv_ip3");	//wrap
                        $focussed_iv.focus();		
                    }
                    else if ($focussed_iv.attr("id") == "iv_gateway0") {
                        $focussed_iv = $("#iv_netmask");	//wrap
                        $focussed_iv.focus();			
                    }
                    else if ($focussed_iv.attr("id") == "iv_dns0") {
                        $focussed_iv = $("#iv_gateway3");	//wrap
                        $focussed_iv.focus();			
                    }
                    else {
                        $focussed_iv.parent().prev().prev().find("input").focus();  //two prevs to skip dot or slash
                    }
                }
			}
			else {
                var maxlen = $focussed_iv.attr("maxlength");
                if ($focussed_iv.val().length < maxlen) {   //enter val
                    var newval = $focussed_iv.val() + $(this).html();
                    $focussed_iv.val(newval);
                    $focussed_iv.focus();
                }
                if ($focussed_iv.val().length == maxlen) {  //go to next box
                    if ($focussed_iv.attr("id") == $last_iv.attr("id")) {
                        $focussed_iv.focus();
                    }
                    else if ($focussed_iv.attr("id") == "iv_ip3") {
                        $focussed_iv = $("#iv_netmask");	//wrap
                        $focussed_iv.focus();		
                    }
                    else if ($focussed_iv.attr("id") == "iv_netmask") {
                        $focussed_iv = $("#iv_gateway0");	//wrap
                        $focussed_iv.focus();			
                    }
                    else if ($focussed_iv.attr("id") == "iv_gateway3") {
                        $focussed_iv = $("#iv_dns0");	//wrap
                        $focussed_iv.focus();			
                    }
                    else {
                        $focussed_iv.parent().next().next().find("input").focus();  //two nexts to skip dot or slash
                    }
                }
			}
		}
	});

    //get valid IP number 0 to 255 from string
    function getIPNum(n) {
        var n = $.trim(n);
        if (n == "") n = 0;
        n = parseInt(n , 10);   //specify base 10 so "010" isn't interpreted as octal
        if (n < 0 || n > 255 || isNaN(n)) n = 0;
        return n;
    }

    //get valid Netmask number 0 to 32 from string
    function getNetmaskNum(n) {
        var n = $.trim(n);
        if (n == "") n = 0;
        n = parseInt(n , 10);   //specify base 10 so "01" isn't interpreted as octal
        if (n < 0 || n > 32 || isNaN(n)) n = 0;
        n = n.toString();   //API expects string
        return n;
    }

    //interface mtu
    $("#interface_mtu_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
            $('#network_interfaces_edit_config_dialog').dialog('close');
            $('#interface_mtu_dialog').dialog('open');
        }
	});

	//interface mtu dialog
	$("#interface_mtu_dialog").dialog({
		dialogClass: 'ui-sm-dialog ui-sm-dialog-notitlebar ui-sm-dialog-with-close mtu-set-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
                var val = parseInt($("#mtu_val").val());
                network_interface_config['MTU'] = val;
                $("#interface_mtu_block_content").html(val);
                enableDisableNWInterfaceOKButton();
				$(this).dialog('close');
                $('#network_interfaces_edit_config_dialog').dialog('open');
			}
		}
	});
	$("#mtu_val").blur(function() {
		$(this).removeClass("focus");
	});
	$("#mtu_val").focus(function() {
		$(this).addClass("focus");
	});

	//handle MTU number keys
	$("#mtu_set_keys div").mousedown(function() {
		var val = $("#mtu_val").val();
		var clickedid = $(this).attr("id");
		if (clickedid == "bkdel") {
			val = val.substring(0, val.length-1);
		}
		else {
			val = val + $(this).text();
		}
		$("#mtu_val").val(val);
	});



    <?php endif; ?>

	/* Network Settings */
	$("#network_settings_server_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			//populate server/port boxes w/ current info
			var serverinfo = network_settings_config['Server'];
			var port = serverinfo.match(/:[0-9]+$/);		//see if there's a port
			if (port != null) {
				var server = serverinfo.substr(0, serverinfo.lastIndexOf(":"));
				var port = serverinfo.substr(serverinfo.lastIndexOf(":")+1);
			}
			else {
				var server = serverinfo;
				var port = "";
			}
			$("#network_settings_server_val").val(server);
			$("#network_settings_port_val").val(port);
			
			$('#network_settings_server_keyboard_dialog').dialog('open');
		}
	});
	//set up network_settings_server_keyboard_dialog
	$("#network_settings_server_keyboard_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var server = $("#network_settings_server_val").val();
				var port = $.trim($("#network_settings_port_val").val());
				if (port != "") server += ":" + port;
				$("#network_settings_server_block_content").html(server);
				network_settings_config['Server'] = server;
				$(this).dialog('close');
				DbHttpProxyConfig(6);	//update IP Settings				
			}
		},
		close: function(event, ui) {
			resetKeyboard("network_settings_server");
		}
	});

	$("#network_settings_user_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			checkPassVals();
			$("#network_settings_username_val").val(network_settings_config['Username']);
			$("#network_settings_password_val").val(network_settings_config['Password']);
			$("#network_settings_repassword_val").val(network_settings_config['Password']);
			$('#network_settings_user_keyboard_dialog').dialog('open');
		}
	});
	//set up network_settings_user_keyboard_dialog
	$("#network_settings_user_keyboard_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var user = $("#network_settings_username_val").val();
				var pass = $("#network_settings_password_val").val();
				network_settings_config['Username'] = user;
				network_settings_config['Password'] = pass;
				var userinfo = "<?= t("USERNAME"); ?>: " + network_settings_config['Username'] + "<br/>"
					+ "<?= t("PASSWORD"); ?>: " + Array(network_settings_config['Password'].length+1).join("*");	//change to *s
				$("#network_settings_user_block_content").html(userinfo);

				$(this).dialog('close');
				DbHttpProxyConfig(6);	//update IP Settings				
			}
		},
		close: function(event, ui) {
			resetKeyboard("network_settings_user");
		}
	});
	
	$("#network_settings_password_val, #network_settings_repassword_val").keyup(function() {
		checkPassVals();
	});
	
	
	//show error text, enabled/disable OK button
	function checkPassVals() {
		if ($("#network_settings_password_val").val() != $("#network_settings_repassword_val").val()) {
			$("#network_settings_user_error").html("<?= t("PASSWORDS_MUST_MATCH"); ?>");
			$("#network_settings_user_keyboard_dialog").next(".ui-dialog-buttonpane").find("button").attr('disabled', 'disabled');	//disableObj function only handles ids
			$("#network_settings_user_keyboard_dialog").next(".ui-dialog-buttonpane").find("button").addClass('ui-state-disabled');
			return false;
		}

		$("#network_settings_user_error").html("");
		$("#network_settings_user_keyboard_dialog").next(".ui-dialog-buttonpane").find("button").removeAttr('disabled');	//disableObj function only handles ids
		$("#network_settings_user_keyboard_dialog").next(".ui-dialog-buttonpane").find("button").removeClass('ui-state-disabled');
		return true;
	}


}