/* vim: set filetype=javascript: */
function loadPushJS() {

	//------------------------------------------------------------
	// SET UP TABS, ADD TASK, DELETE TASK
	//------------------------------------------------------------
	//set up tabs
	$("#push_tab_0").mousedown(function() { selectTab(0); });
	$("#push_tab_1").mousedown(function() { selectTab(1); });
	$("#push_tab_2").mousedown(function() { selectTab(2); });
	$("#push_tab_3").mousedown(function() { selectTab(3); });
	$("#push_tab_4").mousedown(function() { selectTab(4); });

	//when user clicks hash_add button, create new tab, up to MAX_TABS tabs
	$("#push_add_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			TaskReserve('Push');
		}
	});
	//when user clicks clone_cancel button, show confirmation
	$("#push_delete_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			var t = current_task()-15;
			var info = "<?= t("DELETE_PUSH_N_ARE_YOU_SURE", array("1")); ?>";
			if (t == 2) info = "<?= t("DELETE_PUSH_N_ARE_YOU_SURE", array("2")); ?>";
			if (t == 3) info = "<?= t("DELETE_PUSH_N_ARE_YOU_SURE", array("3")); ?>";
			if (t == 4) info = "<?= t("DELETE_PUSH_N_ARE_YOU_SURE", array("4")); ?>";
			if (t == 5) info = "<?= t("DELETE_PUSH_N_ARE_YOU_SURE", array("5")); ?>";

			$('#push_delete_dialog').html(info);
			$('#push_delete_dialog').dialog('open');
		}
	});
	//set up clone_cancel confirmation dialog
	$("#push_delete_dialog").dialog({
		dialogClass: 'ui-conf-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		buttons: {
			'YES': function() {
				$(this).dialog('close');
				TaskRelease(tab_tasks[OP_PUSH][current_tab[OP_PUSH]]);
			}
		}
	});

	//------------------------------------------------------------
	// PUSH MASTER
	//------------------------------------------------------------
	//when user clicks push_master button, open modal dialog with Target Drive options
	$("#push_master_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#clone_master_repo_dialog').dialog('open');
		}
	});

	//set up push_case_dialog
	$("#push_case_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				var cases = [];
				$("#push_case_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) cases.push($(this).find(".col1").text());
				});
                task_config[t]['CaseList'] = cases;
                $(this).dialog('close');
                TaskSetConfiguration({"Task": t, "CaseList": task_config[t]['CaseList']});
			}
		},
		close: function(event, ui) {
            updateModals("push_case");
		}
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
    $("#push_case_select").unbind("mousedown");
	$("#push_case_select").on("mousedown", ".select-opt", function() {
		if ($(this).hasClass("ui-state-disabled")) {
			//do not select disabled
		}
		else {
            $(this).toggleClass("ui-selected");    //toggle selection to allow multiple Case selections
        }
    });


	//------------------------------------------------------------
	// PUSH SETTINGS
	//------------------------------------------------------------
	//when user clicks push_settings button, open modal dialog with Settings options
	$("#push_settings_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#push_settings_dialog').dialog('open');
		}
	});

	//set up clone_settings_dialog
	$("#push_settings_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();

				updateButtons("push_settings");
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
			if ($(this).data('opening_another_dialog') !== true) {
				updateModals("settings");	//only reset modals when Settings X is clicked (not when it closes because HPA, Verify, etc. dialogs are opened)
			}
		}
	});

	//Case Info
	$("#push_case_info_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#push_settings_dialog').data('opening_another_dialog', true).dialog('close');
			$('#clone_case_info_dialog').dialog('open');
		}
	});

	//Verification Method
	$("#push_verif_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#push_settings_dialog').data('opening_another_dialog', true).dialog('close');
			$('#push_verif_dialog').dialog('open');
		}
	});

	//set up push_verif_dialog
	$("#push_verif_dialog").dialog({
		dialogClass: 'ui-sm-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				$("#push_hash_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) task_config[t]["HashType"] = $(this).attr("id").replace("push_hash_", "");    //SHA-256 option missing, so use id instead of i
				});
				$("#push_verif_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) task_config[t]["VerifyHash"] = (i == 0 ? true : false);	//0 button = Yes, 1 button = No
				});

				updateHashVerifBlock();
                updateButtons("settings");
				$(this).dialog('close');
                $('#push_settings_dialog').dialog('open');
				TaskSetConfiguration({"Task": t, "HashType": APIHASHES[task_config[t]["HashType"]], "VerifyHash": task_config[t]["VerifyHash"]});
			}
		}
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#push_hash_select .select-opt").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
            $("#push_hash_select .select-opt").each(function() {
                if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
            });
            $(this).toggleClass("ui-selected");
        }
	});
	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#push_verif_select .select-opt").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$("#push_verif_select .select-opt").each(function() {
				if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
			});
			$(this).toggleClass("ui-selected");
		}
	});

	//------------------------------------------------------------
	// PUSH TARGET
	//------------------------------------------------------------
	//when user clicks clone_target button, open modal dialog with Target Drive options
	$("#push_target_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#clone_target_repo_dialog').dialog('open');
		}
	});
	
	
	
	//pause/unpause config calls on config dialog open/close
	$("#push_case_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#push_case_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#push_settings_dialog").bind("dialogopen", function() {
		$(this).data('opening_another_dialog', false);
		pauseConfigCalls();
	});
	$("#push_settings_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#push_verif_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#push_verif_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});

}
