BODY {
	font-family: <?php print $font_primary; ?>, sans-serif;
	font-weight: normal;
	font-size: 28px;
	color: #fff;
	background: #000 url('<?php print theme_image('page_bg.jpg'); ?>') no-repeat;

	margin: 0;
	padding: 0;
	position: absolute; /* to keep in top left when scaling in Firefox */

	/* disable text selection */
	-webkit-touch-callout: none;
	-webkit-user-select: none;
	-khtml-user-select: none;
	-moz-user-select: none;
	-ms-user-select: none;
	user-select: none;

	/* prevent i-bar cursor (which disappears on system when user plugs in mouse) */
	cursor: default;

	/* initialize zoom/transform */
	zoom: 100%;
	background-size: 1280px;
	transform: none;
	-moz-transform: scale(1);
}

div {
	-moz-user-select: -moz-none;
}

input, td {
	font-family: <?php print $font_primary; ?>, sans-serif;
	font-size: 28px;
	color: #fff; /*#3d3e40;*/
}

button {
	font-size: 25px;
	color: #3d3e40;
}

h1 {
	font-weight: bold;
	text-transform: uppercase;
}

#pdfjs_viewer {
    display: none;
    border: none;
    position: absolute;
    width: 1280px;
    height: 720px;
    z-index: 10020;
}

#debug_bar {
	position: fixed;
	top: 650px;
	left: 650px;
	background-color: #FC9;
	padding: 10px;
	text-align: center;
	color: #000;
	font-size: 13px;
	line-height: 23px;
	z-index: 10021;	/* over everything + 1 */
}
#debug_bar a {
	color: #000;
	font-size: 13px;
}

#datetime {
    display: block;
    position: absolute;
    top: 684px;
    left: 844px;
    width: 400px;
    height: 40px;
    font-weight: bold;
    text-transform: uppercase;
    font-size: 22px;
    text-align: right;
}

#js_error_details_dialog { background: url('<?php print theme_image('modal_dropshadow_details.png'); ?>'); width: 923px !important; height: 444px !important; padding: 30px 50px;  }
#js_error_details_scroller { width: 923px; height: 444px; overflow: auto; }
#js_error_details_scroller td { color: #000; font-size: 29px; letter-spacing: 2px; }

#disabled_gui_status div {
	display: table-cell;
	width: 800px;
	height: 200px;
	vertical-align: bottom;
	text-align: center;
	padding: 160px 200px 320px 320px;
	color: #fff;
}
#disabled_gui_status {
	display: table;
	position: absolute;
	top: 0px;
	left: 0px;
	width: 1280px;
	height: 720px;
	z-index: 10010;	/* over disabled_gui */
}
#disabled_gui {
	position: absolute;
	top: 0px;
	left: 0px;
	width: 1280px;
	height: 720px;
	background: #276575;
	opacity: 0.6;
	filter: alpha(opacity=60);
	z-index: 10000;	/* over everything */
}


#mask {
	position: absolute;
	top: 0px;
	left: 0px;
	width: 1280px;
	height: 720px;
	background: #679a99;
	z-index: 1000;
	display: none;
}


#main {
	display: block;
	position: absolute;
	top: 0px;
	left: 0px;
	width: 1280px;
	height: 720px;
}

#statusbar {
	display: block;
	position: absolute;
	top: 0px;
	left: 0px;
	width: 700px;
	height: 37px;
	padding: 21px 35px;
}

#customer_logo {
	display: block;
	position: absolute;
	top: 0px;
	left: 790px;
	width: 70px;
	height: 70px;
	margin: 5px 0px 4px 100px;
	background: url('<?php print theme_image('customer_logo.png'); ?>') 0px 0px no-repeat;
}
#lock_icon {
	display: block;
	position: absolute;
	top: 0px;
	left: 960px;
	width: 70px;
	height: 60px;
	margin: 11px 10px 8px 10px;
	text-align: center;
	font-size: 18px;
	background: url('<?php print theme_image('zclone_icons.png'); ?>') -1000px 0px no-repeat;
	z-index: 10; /* above #main so it can be clicked */
}
#lock_icon.locked { background-position: -1070px 0px; }

#logo {
	display: block;
	position: absolute;
	top: 0px;
	left: 1050px;
	width: 230px;
	height: 79px;
	<?php if ($LOGICUBE_PLATFORM == "zclonexi"): ?>
	background: url('<?php print theme_image('logo_zclonexi.gif'); ?>') no-repeat;
	<?php elseif ($LOGICUBE_PLATFORM == "zxtower"): ?>
	background: url('<?php print theme_image('logo_zxtower.gif'); ?>') no-repeat;
	<?php elseif ($LOGICUBE_PLATFORM == "zxiforensic"): ?>
	background: url('<?php print theme_image('logo_zxiforensic.gif'); ?>') no-repeat;
	<?php elseif ($LOGICUBE_PLATFORM == "writeprotect"): ?>
	background: url('<?php print theme_image('logo_writeprotect.gif'); ?>') no-repeat;
	<?php else: ?>
	background: url('<?php print theme_image('logo.gif'); ?>') no-repeat;
	<?php endif; ?>
}

#sidebar {
	display: block;
	position: absolute;
	top: 79px;
	left: 0px;
	width: 172px;
	height: 651px;
	padding: 0px 0px 0px 23px;
	overflow: hidden;
	text-align: center;
}
#nav_up { background: url('<?php print theme_image('nav_arrow_up.png'); ?>') center 35px no-repeat #38c2ca; width: 172px; height: 81px; margin-bottom: 5px; border-top-left-radius: 40px; moz-border-radius-topleft: 40px; }
#nav_down { background: url('<?php print theme_image('nav_arrow_down.png'); ?>') center 20px no-repeat #38c2ca; width: 172px; height: 68px; margin-top: 3px; border-bottom-left-radius: 40px; -moz-border-radius-bottomleft: 40px; }
#nav_buttons { height: 482px; }
#nav_buttons .navbtn {
	width: 172px; height: 39px; padding-top: 82px; font-size: 20px; line-height: 18px;
	font-weight: bold; text-transform: uppercase; display: none;
}
#nav_buttons .selected { height: 45px; padding-top: 76px; }
#nav_buttons .navbtn_content { display: table-cell; vertical-align: middle; }

#navbtn_clone {	background: url('<?php print theme_image('zclone_icons.png'); ?>') 0px 3px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_clone.selected { background: url('<?php print theme_image('zclone_icons.png'); ?>') 0px 0px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
#navbtn_hash {	background: url('<?php print theme_image('zclone_icons.png'); ?>') 0px -122px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_hash.selected { background: url('<?php print theme_image('zclone_icons.png'); ?>') 0px -125px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
#navbtn_wipe {	background: url('<?php print theme_image('zclone_icons.png'); ?>') 0px -247px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_wipe.selected { background: url('<?php print theme_image('zclone_icons.png'); ?>') 0px -250px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
#navbtn_push {	background: url('<?php print theme_image('zclone_icons.png'); ?>') 0px -372px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_push.selected { background: url('<?php print theme_image('zclone_icons.png'); ?>') 0px -375px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
#navbtn_task_macro {	background: url('<?php print theme_image('zclone_icons.png'); ?>') 0px -497px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_task_macro.selected { background: url('<?php print theme_image('zclone_icons.png'); ?>') 0px -500px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
#navbtn_usb_device {	background: url('<?php print theme_image('zclone_icons.png'); ?>') 0px -750px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_usb_device.selected { background: url('<?php print theme_image('zclone_icons.png'); ?>') 0px -753px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
#navbtn_logs {	background: url('<?php print theme_image('zclone_icons.png'); ?>') -172px 3px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_logs.selected { background: url('<?php print theme_image('zclone_icons.png'); ?>') -172px 0px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }

<?php if ($LOGICUBE_PLATFORM == "zclonexi"): ?>
#navbtn_stats {	background: url('<?php print theme_image('navbtn_stats_zclonexi.png'); ?>') 0px 3px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_stats.selected { background: url('<?php print theme_image('navbtn_stats_zclonexi.png'); ?>') 0px 0px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
<?php elseif ($LOGICUBE_PLATFORM == "zxtower"): ?>
#navbtn_stats {	background: url('<?php print theme_image('navbtn_stats_zxtower.png'); ?>') 0px 3px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_stats.selected { background: url('<?php print theme_image('navbtn_stats_zxtower.png'); ?>') 0px 0px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
<?php elseif ($LOGICUBE_PLATFORM == "zxiforensic"): ?>
#navbtn_stats {	background: url('<?php print theme_image('navbtn_stats_zxiforensic.png'); ?>') 0px 3px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_stats.selected { background: url('<?php print theme_image('navbtn_stats_zxiforensic.png'); ?>') 0px 0px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
<?php elseif ($LOGICUBE_PLATFORM == "writeprotect"): ?>
#navbtn_stats {	background: url('<?php print theme_image('navbtn_stats_writeprotect.png'); ?>') 0px 3px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_stats.selected { background: url('<?php print theme_image('navbtn_stats_writeprotect.png'); ?>') 0px 0px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
<?php else: ?>
#navbtn_stats {	background: url('<?php print theme_image('zclone_icons.png'); ?>') -172px -122px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_stats.selected { background: url('<?php print theme_image('zclone_icons.png'); ?>') -172px -125px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
<?php endif; ?>

#navbtn_manage_repos {	background: url('<?php print theme_image('zclone_icons.png'); ?>') -172px -247px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_manage_repos.selected { background: url('<?php print theme_image('zclone_icons.png'); ?>') -172px -250px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
#navbtn_settings {	background: url('<?php print theme_image('zclone_icons.png'); ?>') -172px -372px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_settings.selected { background: url('<?php print theme_image('zclone_icons.png'); ?>') -172px -375px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
#navbtn_network_settings {	background: url('<?php print theme_image('zclone_icons.png'); ?>') 0px -623px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_network_settings.selected { background: url('<?php print theme_image('zclone_icons.png'); ?>') 0px -625px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
#navbtn_software {	background: url('<?php print theme_image('zclone_icons.png'); ?>') -172px -497px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_software.selected { background: url('<?php print theme_image('zclone_icons.png'); ?>') -172px -500px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
#navbtn_restart {	background: url('<?php print theme_image('zclone_icons.png'); ?>') -172px -623px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_restart.selected { background: url('<?php print theme_image('zclone_icons.png'); ?>') -172px -625px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
#navbtn_drives {	background: url('<?php print theme_image('zclone_icons.png'); ?>') -172px -750px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_drives.selected { background: url('<?php print theme_image('zclone_icons.png'); ?>') -172px -753px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }
#navbtn_file_browser {	background: url('<?php print theme_image('zclone_icons.png'); ?>') -172px -875px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px 0px no-repeat; }
#navbtn_file_browser.selected { background: url('<?php print theme_image('zclone_icons.png'); ?>') -172px -878px no-repeat, url('<?php print theme_image('navbtn.png'); ?>') 0px -121px no-repeat; }


#content {
	display: block;
	position: absolute;
	top: 79px;
	left: 195px;
	width: 1085px;
	height: 641px;
	padding: 0px;
	overflow: hidden;
	background: url('<?php print theme_image('taskbar_bg.png'); ?>') top left no-repeat;
}

.taskbar, .tabbar {
	display: block;
	position: absolute;
	top: 0px;
	left: 0px;
	width: 1042px;
	height: 67px;
	margin-left: 43px;
	font-family: <?php print $font_secondary; ?>; font-size: 26px; font-weight: normal; text-transform: uppercase;
	z-index: 19;
}
.tabbar {
	background: #00c6cc;
}

.taskpage, .tabpage {
	position: absolute; top: 75px; left: 8px; height: 452px;
	background: rgba(41,103,113,0.7)/*#296771*/; border-radius: 25px; box-shadow: 0px 7px 10px 0px #000;
	z-index: 18;
}
.tabpage { width: 1017px; padding: 34px 24px; }
.taskpage { width: 1037px; padding: 34px 14px; }

/* Buttons and Blocks */
.btn-top {
	float: left; background: url('<?php print theme_image('btn_top.png'); ?>') no-repeat; width: 195px; height: 37px; padding: 13px 10px 8px; text-align: center; color: #fff;
	font-family: <?php print $font_secondary; ?>, sans-serif; font-size: 26px; font-weight: normal; text-transform: uppercase;
}
.btn-bottom {
	float: left; background: url('<?php print theme_image('btn_bottom.png'); ?>') bottom no-repeat; width: 195px; min-height: 23px;
    padding: 13px 10px 17px 10px; text-align: center; word-wrap: break-word;
} /* keep as word-wrap: break-word */
.btn-bottom td:first-child { text-align: left; }
.btn-bottom td:last-child { text-align: left; }
.btn-pill {
	width: 175px; height: 35px; padding: 12px 29px; background: url('<?php print theme_image('btn_pill.png'); ?>') no-repeat; text-align: center; color: #fff;
	font-family: <?php print $font_secondary; ?>, sans-serif; font-size: 24px; font-weight: normal; text-transform: uppercase;
}
.btn-pill-left {
	width: 110px; height: 38px; padding: 6px 32px 6px 18px; background: url('<?php print theme_image('btn_pill_left.png'); ?>') no-repeat; text-align: center; color: #fff;
	font-family: <?php print $font_secondary; ?>, sans-serif; font-size: 28px; font-weight: normal; text-transform: uppercase;
}
.btn-sq {
	width: 180px; height: 108px; padding: 82px 10px 10px; background: url('<?php print theme_image('btn_sq.png'); ?>') no-repeat; text-align: center; color: #000;
	font-family: <?php print $font_secondary; ?>, sans-serif; font-size: 26px; font-weight: normal; text-transform: uppercase; line-height: 32px;
}
.btn-sq.ui-selected {
	background-position: 0px -200px; color: #fff;
}
.btn-sm {
	width: 156px; height: 37px; padding: 11px 10px; background: url('<?php print theme_image('btn_sm.png'); ?>') 0px 0px no-repeat; text-align: center; color: #000;
	font-family: <?php print $font_secondary; ?>, sans-serif; font-size: 24px; font-weight: normal; text-transform: uppercase;
}
.btn-sm.ui-selected {
	background-position: 0px -59px; color: #fff;
}
.btn-med {
	width: 180px; height: 39px; padding: 19px 10px; background: url('<?php print theme_image('btn_med.png'); ?>') 0px 0px no-repeat; text-align: center; color: #000;
	font-family: <?php print $font_secondary; ?>, sans-serif; font-size: 24px; font-weight: normal; text-transform: uppercase;
}
.btn-med.ui-selected {
	background-position: 0px -77px; color: #fff;
}
.btn-tab {
    float: left; display: table; min-width: 100px; height: 68px; color: #000; text-align: center; line-height: 30px; z-index: 20; position: relative;
}
.btn-tab:before { width: 54px; height: 68px; content: ""; display: table-cell; background: url('<?php print theme_image('tab_left.png'); ?>') no-repeat; }
.btn-tab:after { width: 54px; height: 68px; content: ""; display: table-cell; background: url('<?php print theme_image('tab_right.png'); ?>') no-repeat; }
.btn-tab p { display: table-cell; vertical-align: middle; background: url('<?php print theme_image('tab_center.png'); ?>') top repeat-x; padding-top: 5px; min-width: 55px; }
.taskbar .btn-tab:nth-child(1), .tabbar .btn-tab:nth-child(1) { margin-left: -20px; }
.taskbar .btn-tab:nth-child(n+2), .tabbar .btn-tab:nth-child(n+2) { margin-left: -45px; }
.taskbar .btn-tab:nth-child(1), .tabbar .btn-tab:nth-child(1) { z-index: 29; }
.taskbar .btn-tab:nth-child(2), .tabbar .btn-tab:nth-child(2) { z-index: 28; }
.taskbar .btn-tab:nth-child(3), .tabbar .btn-tab:nth-child(3) { z-index: 27; }
.taskbar .btn-tab:nth-child(4), .tabbar .btn-tab:nth-child(4) { z-index: 26; }
.taskbar .btn-tab:nth-child(5), .tabbar .btn-tab:nth-child(5) { z-index: 25; }
.taskbar .btn-tab:nth-child(6), .tabbar .btn-tab:nth-child(6) { z-index: 24; }
.taskbar .btn-tab:nth-child(7), .tabbar .btn-tab:nth-child(7) { z-index: 23; }
.taskbar .btn-tab:nth-child(8), .tabbar .btn-tab:nth-child(8) { z-index: 22; }
.taskbar .btn-tab:nth-child(9), .tabbar .btn-tab:nth-child(9) { z-index: 21; }
.taskbar .btn-tab:nth-child(10), .tabbar .btn-tab:nth-child(10) { z-index: 20; }
.btn-tab.selected { color:#fff; z-index: 30 !important; }
.btn-tab.selected p { background: url('<?php print theme_image('tab_center_on.png'); ?>') top repeat-x; padding-top: 0px; }
.btn-tab.selected:before {
    width: 54px; height: 75px; content: ""; display: table-cell;
    background: url('<?php print theme_image('tab_left_on.png'); ?>') no-repeat;
}
.btn-tab.selected:after {
    width: 54px; height: 75px; content: ""; display: table-cell;
    background: url('<?php print theme_image('tab_right_on.png'); ?>') no-repeat;
}

.btn-block { float: left; background: url('<?php print theme_image('btn_block.png'); ?>'); width: 509px; height: 200px; }
.btn-block-title { float: left; width: 489px; height: 22px; padding: 14px 10px; font-size: 23px; font-weight: bold; text-transform: uppercase; letter-spacing: 1px; color: #fff; text-align: center; }
.btn-block-content { float: left; width: 469px; height: 90px; padding: 20px; font-size: 26px; letter-spacing: 1px; color: #000; text-align: center; word-wrap: break-word; overflow: hidden; } /* keep as word-wrap: break-word */

.btn-block-med { background: url('<?php print theme_image('btn_block_med.png'); ?>'); width: 353px; height: 200px; }
.btn-block-med-title { width: 333px; height: 22px; padding: 14px 10px; font-size: 23px; font-weight: bold; text-transform: uppercase; letter-spacing: 1px; color: #fff; text-align: center; }
.btn-block-med-content { width: 313px; height: 90px; padding: 20px; font-size: 27px; letter-spacing: 1px; color: #000; text-align: center; word-wrap: break-word; overflow: hidden; } /* keep as word-wrap: break-word */

.btn-block-sm { background: url('<?php print theme_image('btn_block_sm.png'); ?>'); width: 252px; height: 200px; }
.btn-block-sm-title { width: 232px; height: 22px; padding: 14px 10px; font-size: 23px; font-weight: bold; text-transform: uppercase; letter-spacing: 1px; color: #fff; text-align: center; }
.btn-block-sm-content { width: 212px; height: 90px; padding: 20px; font-size: 26px; letter-spacing: 1px; color: #000; text-align: center; word-wrap: break-word; overflow: hidden; } /* keep as word-wrap: break-word */

.btn-edit { width: 42px; height: 42px; cursor: pointer; background: url('<?php print theme_image('btn_edit.png'); ?>') no-repeat; margin: 0px auto; }
.btn-edit-on { width: 42px; height: 42px; cursor: pointer; background: url('<?php print theme_image('btn_edit_on.png'); ?>') no-repeat; margin: 0px auto; }

.sas-alert-msg { color: #900 !important; background: url('<?php print theme_image('alert_icon.png'); ?>') no-repeat left 5px; padding-left: 37px; font-weight: bolder; font-style: italic; margin-bottom: 10px; }


/* adjustments to jquery-ui-1.8.11.logicube.css */
.ui-button .ui-button-title { padding-bottom: 10px; }	/* different color for button titles, e.g. "Master" */
.ui-button .ui-button-info, .ui-button-info TD, .ui-button-info { color: #000; font-size: 18px; font-weight: bold; }	/* different font size for button info, e.g. current master drive */
.ui-state-active .ui-button-info, .ui-widget-content .ui-state-active .ui-button-info, .ui-state-active .ui-button-info TD { color: #ffffff; }	/* different color for hovered button titles, e.g. "Master" */


/* Progress Bars */
.ui-progressbar { border-radius: 15px; -moz-border-radius: 15px; background: #8ea1a7; border: none; }

#sb_progressbars { position: absolute; top: 20px; left: 40px; width: 800px; }
#sb_progressbars_info { color: #000; position: absolute; top: 23px; left: 40px; width: 800px; font-size: 21px; font-weight: bold; }

#sb_progressbar_0, #sb_progressbar_1, #sb_progressbar_2, #sb_progressbar_3, #sb_progressbar_4 { width: 110px; height: 30px; float: left; margin-left: 15px; }
#sb_progressbar_0_info, #sb_progressbar_1_info, #sb_progressbar_2_info, #sb_progressbar_3_info, #sb_progressbar_4_info { width: 110px; height: 30px; float: left; text-align: center; margin-left: 15px; color: #000; }

.ui-progressbar .ui-progressbar-value { border-radius: 15px; -moz-border-radius: 15px; border: none !important; background: #679e63 !important; }
.ui-progressbar .ui-widget-header { border: none; background: none; }
.ui-progressbar-aborted .ui-progressbar-value  { background: #e65e50 !important; }
.ui-progressbar-completed .ui-progressbar-value { background: url('<?php print theme_image('bg_check.png'); ?>') no-repeat #679e63 !important; }


/* Select Tables - set up tables, header/select/spacer/footer rows */
table.select_table { border-spacing: 10px 0px; position: relative; left: -6px; }
table.select_table_497 { width: 497px; }
table.select_table_657 { width: 657px; }
table.select_table_770 { width: 770px; }
table.select_table_882 { width: 882px; }
table.select_table_1026 { width: 1026px; }
table.select_table td { font-size: 23px; font-weight: bold; letter-spacing: 2px; color: #000; text-transform: uppercase; text-align: center; }

table.select_table tr.header_row td { background: #d2edf6; height: 60px; border-top-left-radius: 10px; border-top-right-radius: 10px; -moz-border-radius-topleft: 10px; -moz-border-radius-topright: 10px; line-height: 22px;}

table.select_table tr.select_row td { background: #73a5a5; height: 80px; }
table.select_table td.select-more { background: #73a5a5 url('<?php print theme_image('btn_info.png'); ?>') center 22px no-repeat !important; }
table.select_table td.drive-connected { background: #73a5a5 url('<?php print theme_image('bg_drives_check.png'); ?>') center 28px no-repeat !important; }
table.select_table td.drive-not-connected { background: #73a5a5 url('<?php print theme_image('bg_drives_x.png'); ?>') center 28px no-repeat !important; }
table.select_table td.feature-installed { background: #73a5a5 url('<?php print theme_image('bg_drives_check.png'); ?>') center 28px no-repeat !important; }
table.select_table td.feature-not-installed { background: #73a5a5 url('<?php print theme_image('bg_drives_x.png'); ?>') center 28px no-repeat !important; }
table.select_table td.format-repo { background: #73a5a5 url('<?php print theme_image('format_repo.png'); ?>') center 22px no-repeat !important; }
table.select_table td.encrypted-repo { background: #73a5a5 url('<?php print theme_image('encrypted_repo.png'); ?>') right 10px top 22px no-repeat !important; padding-right: 40px; }
table.select_table td.edit-role { background: #73a5a5 url('<?php print theme_image('btn_edit.png'); ?>') right 98px top 22px no-repeat !important; padding-right: 40px; width: 200px; }
table.select_table td.edit-files { background: #73a5a5 url('<?php print theme_image('btn_edit.png'); ?>') right 24px top 22px no-repeat !important; width: 90px; }
table.select_table td.edit-files.ui-state-disabled { background: #73a5a5 url('<?php print theme_image('btn_edit_disabled.png'); ?>') right 24px top 22px no-repeat !important; width: 90px; opacity: 1.0 !important; filter: alpha(opacity=100) !important; }
table.select_table td.sas-alert { width: 100px; background: #73a5a5 url('<?php print theme_image('btn_info_alert.png'); ?>') right 13px top 13px no-repeat !important; }
table.select_table td.hpa-dco-enabled { width: 100px; background: #73a5a5 url('<?php print theme_image('btn_info_warning.png'); ?>') right 13px top 13px no-repeat !important; }
table.select_table tr.ui-selected td.select-more { background: #34767d url('<?php print theme_image('btn_info_on.png'); ?>') center 22px no-repeat !important; }
table.select_table tr.ui-selected td.drive-connected { background: #34767d url('<?php print theme_image('bg_drives_check.png'); ?>') center 28px no-repeat !important; }
table.select_table tr.ui-selected td.drive-not-connected { background: #34767d url('<?php print theme_image('bg_drives_x.png'); ?>') center 28px no-repeat !important; }
table.select_table tr.ui-selected td.feature-installed { background: #34767d url('<?php print theme_image('bg_drives_check.png'); ?>') center 28px no-repeat !important; }
table.select_table tr.ui-selected td.feature-not-installed { background: #34767d url('<?php print theme_image('bg_drives_x.png'); ?>') center 28px no-repeat !important; }
table.select_table tr.ui-selected td.format-repo { background: #34767d url('<?php print theme_image('format_repo_on.png'); ?>') center 22px no-repeat !important; }
table.select_table tr.ui-selected td.encrypted-repo { background: #34767d url('<?php print theme_image('encrypted_repo_on.png'); ?>') right 10px top 22px no-repeat !important; }
table.select_table tr.ui-selected td.edit-role { background: #34767d url('<?php print theme_image('btn_edit_on.png'); ?>') right 98px top 22px no-repeat !important; }
table.select_table tr.ui-selected td.edit-files { background: #34767d url('<?php print theme_image('btn_edit_on.png'); ?>') right 24px top 22px no-repeat !important; }
table.select_table tr.ui-selected td.edit-files.ui-state-disabled { background: #34767d url('<?php print theme_image('btn_edit_disabled.png'); ?>') right 24px top 22px no-repeat !important; }
table.select_table tr.ui-selected td.sas-alert { background: #34767d url('<?php print theme_image('btn_info_alert_on.png'); ?>') right 13px top 13px no-repeat !important; }
table.select_table tr.ui-selected td.hpa-dco-enabled { background: #34767d url('<?php print theme_image('btn_info_warning_on.png'); ?>') right 13px top 13px no-repeat !important; }
table.select_table tr.ui-selected td { background: #34767d; color: #fff; }
table.select_table tr.ui-state-disabled { opacity: 1.0 !important; filter: alpha(opacity=100) !important; }
table.select_table tr.ui-state-disabled td { color: #666; font-style: italic; }

table tr.spacer_row td { background: #7fb7b9; height: 5px; }
table tr.footer_row td { background: #9acccd; height: 41px; border-bottom-left-radius: 10px; border-bottom-right-radius: 10px; -moz-border-radius-bottomleft: 10px; -moz-border-radius-bottomright: 10px; }


/* QWERTY Keyboard modal */
.qwerty_keyboard_shadow_top { position: absolute; top: 90px; left: 36px; width: 1023px; height: 15px; background: url('<?php print theme_image('modal_dropshadow_top_1023.png'); ?>'); z-index: 10; }
.qwerty_keyboard_shadow_right { position: absolute; top: 105px; left: 1044px; width: 15px; height: 474px; background: url('<?php print theme_image('modal_dropshadow_right_474.png'); ?>'); z-index: 10; }
.qwerty_keyboard_shadow_bottom { position: absolute; top: 579px; left: 36px; width: 1023px; height: 15px; background: url('<?php print theme_image('modal_dropshadow_bottom_1023.png'); ?>'); z-index: 10; }
.qwerty_keyboard_shadow_left { position: absolute; top: 105px; left: 36px; width: 15px; height: 474px; background: url('<?php print theme_image('modal_dropshadow_left_474.png'); ?>'); z-index: 10; }

.qwerty_keyboard_top { float: left; width: 971px; height: 85px; margin: 25px 175px 20px 25px; color: #000; font-weight: bold; text-transform: uppercase; }
.qwerty_keyboard_title { float: left; width: 251px; }
.qwerty_keyboard_value { float: left; width: 720px; text-align: right; }
.qwerty_keyboard_value input, .qwerty_keyboard_value textarea { color: #000; border: none; resize: none; font-size: 27px; width: 700px; padding: 1px 10px; }

.qwerty_keyboard { width: 901px; padding: 30px 20px 0px 50px; background: #73a5a5; border-radius: 5px; overflow: hidden; float: left; margin: 0px 175px 25px 25px; }
.qwerty_keyboard div { float: left; margin-right: 30px; margin-bottom: 20px; width: 60px; height: 58px; padding-top: 2px; background: #34767d; font-size: 45px; color: #000; text-align: center; }
.qwerty_keyboard div#qk10 { margin-left: 30px; }
.qwerty_keyboard div#qkshift, #clone_case_info_keyboard div#cidel { width: 105px; font-size: 32px; padding-top: 11px; height: 49px; }
.qwerty_keyboard div#qkabc { width: 235px; font-size: 32px; padding-top: 11px; height: 49px; }
.qwerty_keyboard div#qkabc.smaller { width: 185px; }
.qwerty_keyboard div#qkglobe { background: #34767d url('<?php print theme_image('globe_icon.png'); ?>') 50% 50% no-repeat; }
.qwerty_keyboard div#qkspace { width: 350px; font-size: 32px; padding-top: 11px; height: 49px; }
.qwerty_keyboard div#qkshift.on, .qwerty_keyboard div#qkglobe.on { background-color: #d2edf6; }
.qwerty_val { background: #679a99; }




<?php //include_once("clone_css.php"); //not sure why this is here ?>

